#include <sys/time.h>
#include <unistd.h>
#include <time.h>
#include <errno.h>

/*
 * VOID WINAPI Sleep(
 *   __in  DWORD dwMilliseconds
 *   );
 *   Parameters: dwMilliseconds [in]
 *       The time interval for which execution is to be suspended, in milliseconds.
 */
/*
 * The clock_nanosleep() function suspends execution of the calling process until
 * either microseconds microseconds have elapsed either signal occured
 */ 
void Sleep(int msecs)
{
	struct timespec ts;

	clock_gettime(CLOCK_MONOTONIC, &ts);
	ts.tv_nsec += msecs * 1000000L;
	ts.tv_sec += ts.tv_nsec / 1000000000;
	ts.tv_nsec %= 1000000000;

	while (clock_nanosleep(CLOCK_MONOTONIC, TIMER_ABSTIME, &ts, NULL) && errno == EINTR);
}

unsigned int timeGetTime(void)
{
	struct timeval tv;
	struct timezone tz;
	gettimeofday(&tv, &tz);
	return tv.tv_sec*1000 + tv.tv_usec / 1000;
}
