unit access;

interface

uses Windows;

const RTL2_VERSION = 505;
//   

{-----------------types.h--------------------}
type
  msp_DWORD = Cardinal;
  msp_WORD = Word;
  msp_BYTE = Byte;
  msp_BIT = Byte;
  msp_SIGNED_DWORD = Integer;
  msp_SIGNED_WORD = Smallint;
  msp_SIGNED_BYTE = Shortint;

  DWORD = Cardinal;

  msp_MODE = msp_WORD;
  msp_DIR = msp_BYTE;
  msp_BOOL = msp_BYTE;
  msp_WCHAR = WideChar;

  msp_FLAGID = Cardinal; //??

  msp_HANDLE = msp_DWORD;

  //Pascal-specific addons:
  Pmsp_BYTE = ^msp_BYTE;
  Pmsp_WORD = ^msp_WORD;
  Pmsp_DWORD = ^msp_DWORD;

const
  msp_NOHANDLE = msp_HANDLE(0);
  msp_FALSE = 0;
  msp_TRUE = 1;
  
{-----------------errors.h--------------------}

type msp_ERROR = Integer;
     msp_SSError = Integer;

function msp_GetLastError: msp_ERROR; cdecl;
//    .

function msp_WasError: msp_ERROR; cdecl;
//    ,   .

function msp_GetSystemError(): Integer; cdecl;
//     .

function msp_GetSubsystemError(): msp_SSError; cdecl;
//     (   -    visa)

const
msp_NOERROR				= 0;
msp_ERROR_INVALID_DEVICE_HANDLE	        = 1;
msp_ERROR_INVALID_PARAMETER		          = 2;
msp_ERROR_NOT_INITIALIZED		            = 3;
msp_ERROR_SYSTEM_ERROR			            = 4;
msp_ERROR_DEVICE_BUSY			              = 5;
msp_ERROR_INTERNAL_ACCESS_ERROR	        = 6;
msp_ERROR_NO_HOST_MEMORY		            = 7;
msp_ERROR_ADDRESS_OUT_OF_RAM	          = 8;
msp_ERROR_IRQ_BUSY			                = 9;
msp_ERROR_IRQ_CANCELLED			            = 10;
msp_ERROR_INTERNAL_INTEGRITY_ERROR      = 11;
msp_ERROR_MISSING_DELAY_FUNC            = 12;
msp_ERROR_UNSUPPORTED_FUNCTION          = 13;
msp_ERROR_UNKNOWN_DEVICE_TYPE	          = 14;
msp_ERROR_UNSUPPORTED_DRIVER_TYPE	      = 15;
msp_ERROR_UNSUPPORTED_BUS_TYPE	        = 16;
msp_ERROR_DRIVER_NOT_FOUND		          = 17;

msp_ERROR_NO_FREE_RAM			            = 20;
msp_ERROR_INVALID_RAM_HANDLE	        = 21;
msp_ERROR_ILLEGAL_HANDLE_TYPE	        = 22;
msp_ERROR_HANDLE_OUT_OF_SCOPE	        = 23;
msp_ERROR_HANDLE_IN_USE			          = 24;
msp_ERROR_ADDRESS_OUT_OF_OBJECT	      = 25;

msp_ERROR_INVALID_FLAG			= 30;
msp_ERROR_INVALID_VREG			= 31;
msp_ERROR_UNSUPPORTED_MODE		= 32;
msp_ERROR_MODE_NOT_SELECTED		= 33;
msp_ERROR_INCOMPATIBLE_MODE		= 34;
msp_ERROR_INCOMPATIBLE_CONFIGURATION	= 35;
msp_ERROR_FRAM_NOT_RESERVED		= 36;

msp_ERROR_INCOMPATIBLE_STACK	        = 40;
msp_ERROR_INCOMPATIBLE_FRAME	        = 40;
msp_ERROR_NOT_LOADED			            = 41;
msp_ERROR_INDEX_OUT_OF_RANGE	        = 42;
msp_ERROR_NO_NEXT_MESSAGE		          = 43;
msp_ERROR_MESSAGE_IN_PROGRESS	        = 44;

msp_ERROR_INVALID_MESSAGE_FORMAT	= 50;
msp_ERROR_MESSAGE_FIELD_NOT_EXISTS	= 51;
msp_ERROR_FRAME_EXCEEDS_SIZE_LIMIT	= 52;

msp_ERROR_INCOMPATIBLE_BUFFER	        = 60;
msp_ERROR_BUFFER_NOT_CONNECTED          = 61;
msp_ERROR_BUFFER_BUSY_SAFE		= 62;
msp_ERROR_BUFFER_BUSY_UNSAFE	        = 63;
msp_ERROR_STREAM_DISABLED		= 64;
msp_ERROR_STREAM_IN_USE			= 65;
msp_ERROR_STREAM_CORRUPTED		= 66;
msp_ERROR_ILLEGAL_COMMAND_WORD	        = 67;
msp_ERROR_NOT_MODE_CODE			= 68;

msp_ERROR_TOO_MANY_FRAMES		= 70;
msp_ERROR_INVALID_MESSAGE_HANDLE	= 71;
msp_ERROR_INVALID_FRAME_HANDLE		= 72;

msp_ERROR_ANSWER_NOT_MATCH		= 80;
msp_ERROR_ANSWER_MISSING_WORDS		= 81;
msp_ERROR_ANSWER_EXTRA_WORDS		= 82;
msp_ERROR_INVALID_MESSAGE		= 83;
msp_ERROR_ANSWER_ERROR			= 84;
msp_ERROR_ANSWER_ANOTHER_CHANNEL	= 85;
msp_ERROR_ANSWER_RT_BUSY		 = 86;

msp_ERROR_INTERNAL_ALGORITHM		= 90;

///////////   USB ////////////////
msp_ERROR_EMPTY_FRAME			= 100;
msp_ERROR_OVERLOAD_BUFFERS		= 101;
msp_ERROR_INVALID_REQUEST		= 102;

msp_ERROR_USB_EXCHANGE			= 200;
msp_ERROR_USB_NOT_SUPPORT		= 201;
msp_ERROR_USB_ACCESS			= 202;
msp_ERROR_USB_FTDI_ERROR  = 203;
msp_ERROR_USB_RESPONSE_TIMEOUT = 204;
msp_ERROR_USB_RESPONSE_FAILURE = 205;

msp_ERROR_DEVICES_NOT_FOUND		= 210;

//////////    cash /////////////
msp_ERROR_CASH_DEVICE_TABLE_OVERLOAD	= 301;
msp_ERROR_DEVICE_NOT_INTO_CASH		= 302;
msp_ERROR_CASH_INCORRECT_CALL_FUNCTION	= 303;

msp_ERROR_VXI_ERROR = 320;

{-----------------access.h--------------------}
type

  msp_BusType = (msp_Bus_unusedCode_0,
      msp_Bus_PCI,
      msp_Bus_USB,
      msp_Bus_NULL,
      msp_Bus_VXI);
  msp_DriverType = (msp_Driver_unusedCode_0,
    msp_Driver95,
    msp_DriverNT,
    msp_DriverRTX,
    msp_DriverNT_USB,
    msp_DriverLinux,
    msp_DriverLinux_USB,
    msp_DriverFBSD,
    msp_DriverFBSD_USB,
    msp_Driver_VXI,
    msp_Driver_USB_FTDI,
    msp_Driver7,
    msp_Driver_NULL);

const
  msp_MAX_BUS_TYPE = msp_Bus_VXI;
  msp_MAX_DRIVER_TYPE = msp_Driver_NULL;

//   
  mspLT_BU              = $00; //  BU-61580,   //
  mspLT_PLM_BU		= $01; //  18791  ,  
  mspLT_TESTER		= $02; //   ()
  mspLT_EXT_TESTER	= $03; //   +   (UNIVERSAL)
  mspLT_MULTIPORT	= $04; // 31 +  
  mspLT_VIRTUALRT	= $FE; //     mspLT_MULTIPORT

//   
//BoardTypeId -     (4 hex    )
  msp_BOARD_Unknown = 0;
  msp_BOARD_MBXXXX  = 0;
  msp_BOARD_MB1101  = $1101;
  msp_BOARD_MB1104  = $1104;
  msp_BOARD_MB2604  = $2604;
  msp_BOARD_MB2603  = msp_BOARD_MB2604;
  msp_BOARD_MB2614  = $2614;
  msp_BOARD_MB2605  = msp_BOARD_MB2614;
  msp_BOARD_MB2615  = msp_BOARD_MB2614;
  msp_BOARD_MB2616  = $2616;
  msp_BOARD_MB2617  = $2617;
  msp_BOARD_MB2619  = $2619;
  msp_BOARD_MB2620  = $2620;
  msp_BOARD_MB2630  = $2630;
  msp_BOARD_MB2634  = $2634;
  msp_BOARD_MB5601  = $5601;
  msp_BOARD_NULL    = $DEAD;
  msp_BOARD_nonMB   = $7FFE;
  msp_BOARD_unIDENT = $7FFF;

//  
  msp_MODE_NOT_DEFINED            = $0000;
  msp_MODE_BC                     = $0001;
  msp_MODE_RT                     = $0002;
  msp_MODE_MM                     = $0004;
  msp_MODE_WM                     = $0008;
  msp_MODE_IDLE			  = $0010;
  msp_MODE_ENHANCED		  = $8000;
  msp_MODE_WG			  = $0020; //  
  msp_MODE_MRT			  = $0040; //  MRT

// ()  SelectMode
  msp_SWITCH_WITHOUT_RESET        = $0100;
  msp_SWITCH_KEEP_RAM             = $0200;
  msp_WG_FIRST			  = 0;
  msp_WM_FIRST			  = $4000;

//   
  msp_CLOCK_12MHz = 1;
  msp_CLOCK_16MHz = 0;
  msp_CLOCK_24MHz = 2;
  msp_CLOCK_48MHz = 3;

type
  msp_DeviceInfo =
    record
        VendorId:   msp_SIGNED_WORD;
        DeviceId:   msp_SIGNED_WORD;
        SubsystemVendorId: msp_SIGNED_WORD;
        SubsystemId: msp_SIGNED_WORD;
        InstanceId: msp_SIGNED_DWORD;
        ProcessId:  msp_SIGNED_DWORD;
        LType:      msp_SIGNED_DWORD;
        BusType:    msp_SIGNED_DWORD;
        DriverType: msp_SIGNED_DWORD;
        Busy:       msp_SIGNED_WORD;
        SerialNumber: ^msp_WCHAR;
    end;

(*
  
VendorId    (   PCI)
DeviceId    (   PCI)
InstanceId       PCI.
			    PCI CONFIG_ADDRESS ( 31 = 0).
ProcessId    (),  ,  0,
			  
   0  msp_GetNumberOfDevices()-1.
*)

  msp_DeviceTypeInfo =
    record
	BoardTypeId:    msp_DWORD; (*    
                                     (4 hex    ) *)
	BoardTypeName:  PChar;     (*   , ,
                                      RUS windows-1251 *)
	Clocks:         msp_BYTE;  (*    (OR'ed (1 << MSP_CLOCK_XXX)) *)
	Modes:          ^msp_MODE; (*    
                                       ,   - 0 *)
	OnChipRamSize:  msp_DWORD;  (*  ,  *)
	OnBoardRamSize:  msp_DWORD;  (*  ,  *)
	OnSpecialRamSize:  msp_DWORD;  (*     (, 31),  *)
    end;
  Pmsp_DeviceTypeInfo = ^msp_DeviceTypeInfo;

  msp_DeviceInfoEx =
    record
	VendorId:       msp_SIGNED_WORD;
	DeviceId:       msp_SIGNED_WORD;
	SubsystemVendorId: msp_SIGNED_WORD;
	SubsystemId:    msp_SIGNED_WORD;
	InstanceId:     msp_SIGNED_DWORD;
	ProcessId:      msp_SIGNED_DWORD;
	LType:          msp_SIGNED_DWORD;
	BusType:        msp_SIGNED_DWORD;
	DriverType:     msp_SIGNED_DWORD;
	Busy:           msp_SIGNED_DWORD;
  SerialNumber:   ^msp_WCHAR;
	BoardTypeId:    msp_SIGNED_DWORD;
	BoardTypeName:  PChar;
	Clocks:         msp_SIGNED_BYTE;
	Modes:          ^msp_MODE;
	ModesMask:      msp_SIGNED_WORD;  (* OR'ed Modes *)
	OnChipRamSize:  msp_SIGNED_DWORD;
	OnBoardRamSize:  msp_SIGNED_DWORD;
	OnSpecialRamSize:  msp_SIGNED_DWORD;
    end;
    //      


type

  HANDLE = System.THandle;
  msp_DEVHANDLE = msp_HANDLE;

(***************************************************************
        
 ***************************************************************)

function msp_GetVersion(): msp_WORD; cdecl;
//     (  RTL2_VERSION)
//     ,     DLL


function msp_Startup: msp_ERROR; cdecl;
//  RTL

function msp_Cleanup: msp_ERROR; cdecl;
//   RTL

function msp_StartupDrv(drv: msp_DriverType): msp_ERROR; cdecl;
//  RTL

function msp_GetNumberOfDevices: integer; cdecl;
//   .
// -1   

function msp_GetDeviceInfo(n: integer; var I: msp_DeviceInfo): msp_ERROR; cdecl;

//         i   DeviceInfo:
//   0  msp_GetNumberOfDevices()-1.

function msp_FindDevice(var I: msp_DeviceInfo): integer; cdecl;

//      , -1    .
//       I.
//         1.
//   0  msp_GetNumberOfDevices()-1.

procedure msp_InitPattern(var I: msp_DeviceInfo);
// I     "  "
//     I  

function msp_GetDeviceTypeInfo(i: integer): Pmsp_DeviceTypeInfo; cdecl;
//           i.
//	   NULL    
//		( msp_ERROR_UNKNOWN_DEVICE_TYPE, msp_ERROR_INVALID_PARAMETER, msp_ERROR_NOT_INITIALIZED).
//   0  msp_GetNumberOfDevices()-1.

function msp_GetDeviceInfoEx(i: integer; var II: msp_DeviceInfoEx): msp_ERROR; cdecl;
//-  msp_GetDeviceInfo(),    
//    ,    - ,  
//   -1,   msp_ERROR_UNKNOWN_DEVICE_TYPE

function msp_FindDeviceEx(var I: msp_DeviceInfoEx; next: integer): integer; cdecl;
const msp_FIND_FIRST = 0; msp_FIND_NEXT = 1; //  next
//-  msp_FindDevice(),     .
//   
// BoardTypeName 
// SerialNumber 
// Modes,  ,     NULL
// Clocks  ModesMask  "  ",
// Modes - "  "
//next -     msp_FIND_XXXX

procedure msp_InitPatternEx(var I: msp_DeviceInfoEx);
// I     "  "
//     I  

(***************************************************************
        
 ***************************************************************)

function mspi_OpenAccess(i: integer): msp_DEVHANDLE; cdecl;
function mspi_OpenAccessEx(i, flags: integer): msp_DEVHANDLE; cdecl;

//    
//    
//  msp_NOHANDLE.

//flags:
const
  msp_of64 =	        (1 shl 0);
  msp_ofZEROWAIT =	(1 shl 1);
  msp_ofBackDoor =	(1 shl 2);
  msp_ofShrinkRam =	(1 shl 3);

function mspi_CloseAccess(device: msp_DEVHANDLE ): msp_ERROR; cdecl;
//    

function msp_GetDeviceNo(device: msp_DEVHANDLE): integer; cdecl;
//   

function mspi_OpenBackDoor(i: integer): msp_DEVHANDLE; cdecl;
//        
//  .

function mspi_SwitchBackDoorBank(device: msp_DEVHANDLE; code: integer): msp_ERROR; cdecl;
// .
//code:         0      - internal 4KW
//              1      - external A 64KW
//              2      - external B 64KW


{-----------------config.h--------------------}

function msp_Open(i: integer): msp_DEVHANDLE; cdecl;

//    .
//    
//  msp_NOHANDLE.

function msp_Close(device: msp_DEVHANDLE): msp_ERROR; cdecl;

//    .

{-----------------access.h--------------------}

(***************************************************************
         
 ***************************************************************)

function mspi_OpenAccess_Multi(device: msp_DEVHANDLE; i: integer): msp_DEVHANDLE; cdecl;
//   ()  
//device -  
//i -  
// device     msp_MODE_MRT    14  CONFIG2
//  msp_Open_Multi() (config.h)

const
//   
ofs_MRT_REGISTER_OVERRIDE = 3;
mask_MRT_REGISTER_OVERRIDE = msp_WORD(1 shl ofs_MRT_REGISTER_OVERRIDE);
ofs_MRT_ATOMIC_RW = 4;
mask_MRT_ATOMIC_RW = msp_WORD(1 shl ofs_MRT_ATOMIC_RW);

(***************************************************************
       USB
 ***************************************************************)

//   USB 
const
  USB_POWER_EXTERNAL = 1;
  USB_POWER_INTERNAL = 0;
//   USB 
// code = USB_POWER_EXTERNAL -   
//      = USB_POWER_INTERNAL -   USB
function msp_USB_SwitchPower( device: msp_DEVHANDLE; code: integer): msp_ERROR; cdecl;

(***************************************************************
         
 ***************************************************************)

//    . RegNo   .

function msp_ReadReg(device: msp_DEVHANDLE; RegNo: msp_BYTE): msp_WORD; cdecl;
function msp_WriteReg(device: msp_DEVHANDLE; RegNo: msp_BYTE; Data: msp_WORD): msp_ERROR; cdecl;

//         . Address     .

function msp_ReadRamW   (device: msp_DEVHANDLE; Address: msp_WORD): msp_WORD; cdecl;
function msp_WriteRamW  (device: msp_DEVHANDLE; Address: msp_WORD;  Data: msp_WORD): msp_ERROR; cdecl;
function msp_ReadRamDW  (device: msp_DEVHANDLE; Address: msp_WORD): msp_DWORD; cdecl;
function msp_WriteRamDW (device: msp_DEVHANDLE; Address: msp_WORD; Data: msp_DWORD): msp_ERROR; cdecl;

function msp_ReadRam    (device: msp_DEVHANDLE; Address: msp_WORD): msp_WORD; cdecl;
function msp_WriteRam   (device: msp_DEVHANDLE; Address: msp_WORD;  Data: msp_WORD): msp_ERROR; cdecl;
// 

//          .
//   

function msp_ReadRamBLK  (device: msp_DEVHANDLE; Address: msp_WORD; var Data; Length: msp_WORD): msp_ERROR; cdecl;
function msp_WriteRamBLK (device: msp_DEVHANDLE; Address: msp_WORD; var Data; Length: msp_WORD): msp_ERROR; cdecl;

//     .
function msp_FillRamBLK (device: msp_DEVHANDLE; Address: msp_WORD; Data: msp_WORD; Length: msp_WORD): msp_ERROR; cdecl;

//          
//    .
//NextAddress .. NULL.
function msp_ReadRamCIRC(device: msp_DEVHANDLE; Address: msp_WORD; var Data;
						  Length: msp_WORD; Modulo: msp_DWORD; NextAddress: Pmsp_WORD): msp_ERROR; cdecl;
function msp_WriteRamCIRC(device: msp_DEVHANDLE; Address: msp_WORD; var Data;
						  Length: msp_WORD; Modulo: msp_DWORD; NextAddress: Pmsp_WORD): msp_ERROR; cdecl;


//     PCI. RegNo -  . 
//      RTL    
//      
function msp_LPCI_ReadReg(device: msp_DEVHANDLE; RegNo: msp_BYTE): msp_DWORD; cdecl;
function msp_LPCI_WriteReg(device: msp_DEVHANDLE; RegNo: msp_BYTE; Data: msp_DWORD): msp_ERROR; cdecl;

// My function
//function msp_Configure(device: msp_DEVHANDLE; mode: msp_MODE; var flags; var regvalues): msp_ERROR; cdecl;

{*************************************************************************
   
  0x00-0x0F  - (BU-61580)
  0x10-0x1F  -   (BU-61580)
  0x20-0x21	 :    
**************************************************************************}

const

mspRR_INTERRUPT_MASK			= $00;
mspRR_CONFIG1				= $01;
mspRR_CONFIG2				= $02;
mspRR_COMMAND				= $03;
mspRR_COMMAND_STACK_POINTER		= $03;
mspRR_CONTROL_WORD			= $04;
mspRR_TIME_TAG				= $05;
mspRR_INTERRUPT_STATUS			= $06;
mspRR_CONFIG3				= $07;
mspRR_CONFIG4				= $08;
mspRR_CONFIG5				= $09;
mspRR_DATA_STACK_ADDRESS		= $0A;
mspRR_FRAME_TIME_REMAINING		= $0B;
mspRR_MESSAGE_TIME_REMAINING            = $0C;
mspRR_BC_FRAME_TIME			= $0D;
mspRR_RT_LAST_COMMAND			= $0D;
mspRR_MT_TRIGGER			= $0D;
mspRR_RT_STATUS_WORD			= $0E;
mspRR_RT_BIT_WORD			= $0F;
mspRR_MRT_ADDRESS			= $10;
mspRR_MRT_CONFIG1			= $11;
mspRR_MRT_STATUS			= $15;
mspRR_MRT_INTERRUPT_STATUS		= $16;
//Test mode registers 0x10-0x17 are not defined here
//but still accessible
mspRR_CONFIG6         = $18;
mspRR_MRT_COMMAND_WORD			= $1D;
mspRR_MRT_STATUS_WORD			= $1E;

//External registers:
mspRR_EXTERNAL_CONFIG			  = $20;
mspRR_EXTERNAL_RT_ADDRESS		= $21;
mspRR_EXTERNAL_CDIVIDER     = $22;
mspRR_EXTERNAL_FLOG_ID			= $23;
mspRR_EXTERNAL_USB_POWER		= $24;
mspRR_EXTERNAL_USB_FIRMWARE_VERSION = $25;
mspRR_EXTERNAL_USB_COMMAND  = $26;
//Software registers:
mspRR_SOFTWARE1				= $FF;
mspRR_SOFTWARE2_MRT_ISR			= $FE;
mspRR_SOFTWARE_LOW    = mspRR_SOFTWARE2_MRT_ISR;
//:
mspRR_WG_DATA_STACK_POINTER		= $03;
mspRR_WG_INITIAL_DATA_STACK_POINTER	= $04;

{*************************************************************************
    PCI 9050
        RTL
          
   
**************************************************************************}

LPCI_LAS0RR	= $00;
LPCI_LAS1RR	= $01;
LPCI_LAS2RR	= $02;
LPCI_LAS3RR	= $03;
LPCI_EROMRR	= $04;
LPCI_LAS0BA	= $05;
LPCI_LAS1BA	= $06;
LPCI_LAS2BA	= $07;
LPCI_LAS3BA	= $08;
LPCI_EROMBA	= $09;
LPCI_LAS0BRD	= $0A;
LPCI_LAS1BRD	= $0B;
LPCI_LAS2BRD	= $0C;
LPCI_LAS3BRD	= $0D;
LPCI_EROMBRD	= $0E;
LPCI_CS0BASE	= $0F;
LPCI_CS1BASE	= $10;
LPCI_CS2BASE	= $11;
LPCI_CS3BASE	= $12;
LPCI_INTCSR	= $13;
LPCI_CNTRL	= $14;

(*************************************************************************
   
**************************************************************************)

type
  msp_ISR = procedure (device: msp_DEVHANDLE); cdecl;

function msp_SetISR (device: msp_DEVHANDLE; ISR: msp_ISR): msp_ERROR; cdecl;
// /      (device).
//     ,
//     9050

implementation

procedure msp_InitPattern(var I: msp_DeviceInfo);
begin
  FillChar(I, SizeOf(I), -1);
  I.SerialNumber := nil;
end;
procedure msp_InitPatternEx(var I: msp_DeviceInfoEx);
begin
  FillChar(I, SizeOf(I), -1);
  I.Modes := nil;
  I.SerialNumber := nil;
end;


function msp_GetLastError; external 'drtl3.dll' name 'msp_GetLastError';
function msp_WasError; external 'drtl3.dll' name 'msp_WasError';
function msp_GetSystemError; external 'drtl3.dll' name 'msp_GetSystemError';
function msp_GetSubsystemError; external 'drtl3.dll' name 'msp_GetSubsystemError';
function msp_GetVersion; external 'drtl3.dll' name 'msp_GetVersion';
function msp_Startup; external 'drtl3.dll' name 'msp_Startup';
function msp_Cleanup; external 'drtl3.dll' name 'msp_Cleanup';
function msp_GetNumberOfDevices; external 'drtl3.dll' name 'msp_GetNumberOfDevices';
function msp_GetDeviceInfo; external 'drtl3.dll' name 'msp_GetDeviceInfo';
function msp_FindDevice; external 'drtl3.dll' name 'msp_FindDevice';
function msp_Open; external 'drtl3.dll' name 'mspi_Open';
function msp_Close; external 'drtl3.dll' name 'mspi_Close';
function mspi_OpenBackDoor; external 'drtl3.dll' name 'mspi_OpenBackDoor';
function mspi_SwitchBackDoorBank; external 'drtl3.dll' name 'mspi_SwitchBackDoorBank';
function msp_GetDeviceNo; external 'drtl3.dll' name 'msp_GetDeviceNo';
function msp_ReadReg; external 'drtl3.dll' name 'msp_ReadReg';
function msp_WriteReg; external 'drtl3.dll' name 'msp_WriteReg';
function msp_ReadRamW; external 'drtl3.dll' name 'msp_ReadRamW';
function msp_WriteRamW; external 'drtl3.dll' name 'msp_WriteRamW';
function msp_ReadRamDW; external 'drtl3.dll' name 'msp_ReadRamDW';
function msp_WriteRamDW; external 'drtl3.dll' name 'msp_WriteRamDW';
function msp_ReadRam; external 'drtl3.dll' name 'msp_ReadRamW';
function msp_WriteRam; external 'drtl3.dll' name 'msp_WriteRamW';
function msp_ReadRamBLK; external 'drtl3.dll' name 'msp_ReadRamBLK';
function msp_WriteRamBLK; external 'drtl3.dll' name 'msp_WriteRamBLK';
function msp_FillRamBLK; external 'drtl3.dll' name 'msp_FillRamBLK';
function msp_ReadRamCIRC; external 'drtl3.dll' name 'msp_ReadRamCIRC';
function msp_WriteRamCIRC; external 'drtl3.dll' name 'msp_WriteRamCIRC';
function msp_LPCI_ReadReg; external 'drtl3.dll' name 'msp_LPCI_ReadReg';
function msp_LPCI_WriteReg; external 'drtl3.dll' name 'msp_LPCI_WriteReg';
function msp_SetISR; external 'drtl3.dll' name 'msp_SetISR';
//function msp_Configure; external 'drtl3.dll' name 'msp_Configure';
function msp_StartupDrv; external 'drtl3.dll' name 'msp_StartupDrv';
function msp_GetDeviceTypeInfo; external 'drtl3.dll' name 'msp_GetDeviceTypeInfo';
function msp_GetDeviceInfoEx; external 'drtl3.dll' name 'msp_GetDeviceInfoEx';
function msp_FindDeviceEx; external 'drtl3.dll' name 'msp_FindDeviceEx';
function mspi_OpenAccess; external 'drtl3.dll' name 'mspi_OpenAccess';
function mspi_OpenAccessEx; external 'drtl3.dll' name 'mspi_OpenAccessEx';
function mspi_CloseAccess; external 'drtl3.dll' name 'mspi_CloseAccess';
function mspi_OpenAccess_Multi; external 'drtl3.dll' name 'mspi_OpenAccess_Multi';
function msp_USB_SwitchPower; external 'drtl3.dll' name 'msp_USB_SwitchPower';

end.
