unit bc;

interface

uses access, config;

(***************************************************************
    .
 ***************************************************************)

type
msp_MSGHANDLE = msp_RAMHANDLE;
msp_FRMHANDLE = msp_STKHANDLE;

Pmsp_MSGHANDLE = ^msp_MSGHANDLE;
PPmsp_MSGHANDLE = ^Pmsp_MSGHANDLE;

(***************************************************************
   Working with messaqes: creating, deleting, expecting,
   editing, etc.
 ***************************************************************)

function msp_FormatMessage(
		buffer: Pmsp_Message;
		type_: msp_BYTE;
		RT: msp_BYTE;
		SA: msp_BYTE;
		RTR_MC: msp_BYTE;
		SAR_MCD: msp_WORD;
		dataWordCount: msp_BYTE;
		data: Pmsp_WORD;
		bccw: msp_DWORD
): Pmsp_Message; cdecl;
//  
//     msp_Message.
//:
//buffer     
//type    (   mspM_XXXX)
//RT   (0-31)
//SA   (0-31)
//RTR_MC, SAR_MCD -     mspM_RTtoRT
//                -     mspM_MODECODE_XXXX
//dataWordCount    .
//data  .   NULL,
//                   buffer->data  .
//bccw -    (bitmapped). 3 .  .
//: *buffer.

//    msp_FornatMessage
function  msp_BCtoRT(B: Pmsp_Message; RT,SA,wcnt: msp_BYTE; data: Pmsp_WORD; cw: msp_DWORD): Pmsp_Message;
function  msp_RTtoBC(B: Pmsp_Message; RT, SA: msp_BYTE;wcnt: msp_BYTE;cw: msp_DWORD): Pmsp_Message;
function  msp_RTtoRT(B: Pmsp_Message; RT, SA, RTR: msp_BYTE; SAR: msp_WORD; wcnt: msp_BYTE; cw: msp_DWORD): Pmsp_Message;
function  msp_BCtoRT_bcst(B: Pmsp_Message; RT, SA : msp_BYTE; wcnt: msp_BYTE; data: Pmsp_WORD; cw: msp_DWORD): Pmsp_Message;
function  msp_RTtoRT_bcst(B: Pmsp_Message; RT, SA: msp_BYTE; SAR: msp_WORD; wcnt: msp_BYTE; cw: msp_DWORD): Pmsp_Message;
function  msp_Modecode(B: Pmsp_Message; RT, MC : msp_BYTE; cw: msp_DWORD): Pmsp_Message;
function  msp_Modecode_data_tx(B: Pmsp_Message; RT, MC : msp_BYTE; cw: msp_DWORD): Pmsp_Message;
function  msp_Modecode_data_rx(B: Pmsp_Message; RT, MC : msp_BYTE; MCD: msp_WORD; cw: msp_DWORD): Pmsp_Message;
function  msp_Modecode_bcst(B: Pmsp_Message; MC : msp_BYTE; cw: msp_DWORD): Pmsp_Message;
function  msp_Modecode_data_bcst(B: Pmsp_Message; MC : msp_BYTE; MCD: msp_WORD; cw: msp_DWORD): Pmsp_Message;
//msp_Message* B  <= buffer
//msp_WORD RT, SA <= address (single or source)
//msp_WORD RTR, SAR <= destination address
//msp_WORD wcnt <= data word cont
//msp_WORD* data <= transfer data
//msp_WORD MC <= mode code
//msp_WORD MCD <= modecode data
//msp_WORD cw <= BCCW

//  BCCW:
// msp_CreateMessage  0-2    buffer->type
//   
//BCCW_EX    msp_FormatMessage     msp_Message
const
 msp_BCCW_RT_TO_RT_FORMAT		= $0001;
 msp_BCCW_BROADCAST_FORMAT		= $0002;
 msp_BCCW_MODE_CODE_FORMAT		= $0004;
 msp_BCCW_1553A					= $0008;
 msp_BCCW_1553B					= $0000;
 msp_BCCW_EOM_INTR_ENABLE		= $0010;
 msp_BCCW_MASK_BROADCAST			= $0020;
 msp_BCCW_SELFTEST				= $0040;
 msp_BCCW_CHANNEL_A				= $0080;
 msp_BCCW_CHANNEL_B				= $0000;
 msp_BCCW_RETRY_ENABLED			= $0100;
 msp_BCCW_RESERVED_MASK			= $0200;
 msp_BCCW_TERMINAL_FLAG_MASK		= $0400;
 msp_BCCW_SUBSYSTEM_FLAG_MASK	= $0800;
 msp_BCCW_BUSY_MASK				= $1000;
 msp_BCCW_SERVICE_REQUEST_MASK	= $2000;
 msp_BCCW_MESSAGE_ERROR_MASK		= $4000;
 msp_BCCW_EX_BROADCAST_DISABLED = $10000;

procedure msp_SetDefault_BCCW(value: msp_DWORD); cdecl;
//     OR   bccw
//    msp_FormatMessage

function msp_CreateMessage(device: msp_DEVHANDLE; buffer: Pmsp_Message):msp_MSGHANDLE; cdecl;
//    .
//device   .
//buffer   
//:  (handle) .

function msp_DestroyMessage(msg: msp_MSGHANDLE): msp_ERROR;
//    .

function msp_ReadBCMessage(message: msp_MSGHANDLE ;  var buffer: msp_Message): msp_ERROR ; cdecl;
// (  )     
//  msp_Message,   StatusWord1/2, loopback.
//       
//    ( )   ( buffer).
//message  . (handle) 
//buffer    

function msp_ReadMessageData(message: msp_MSGHANDLE;  buffer: Pmsp_WORD; wordcount: msp_BYTE):msp_BYTE; cdecl;
//      

function msp_WriteMessageData(message: msp_MSGHANDLE;  buffer: Pmsp_WORD; wordcount: msp_BYTE):msp_BYTE; cdecl;
//      
//message - 
//buffer -

function msp_ReadMessageWord(message: msp_MSGHANDLE; word: msp_BYTE): msp_WORD; cdecl;
//      .
//message - 
//word -  .
//  0-31 (  )   msp_MW_XXXX

function msp_WriteMessageWord(message: msp_MSGHANDLE; word: msp_BYTE; value: msp_WORD):msp_ERROR;cdecl;
//      .
//message - 
//word -  .
//value -  
//  0-31 (  )   msp_MW_XXXX

const
 msp_MW_BCCW =			32;
 msp_MW_CMD1 =			33;
 msp_MW_CMD2 =			34;
 msp_MW_STATUS1	=	35;
 msp_MW_STATUS2	=	36;
 msp_MW_LOOPBACK =		37;
 msp_MW_WORDCOUNT =	38;
 msp_MW_MODECODE =		39;
//msp_MW_WORDCOUNT, msp_MW_MODECODE -  , 5-   CMD1

(***************************************************************
     : , ,  ,
   , 
 ***************************************************************)

function msp_CreateFrame(device: msp_DEVHANDLE; FrameTime: msp_WORD; MessageCount: msp_WORD):msp_FRMHANDLE ; cdecl;
//     ,  .
//device
//FrameTime       100 (?).
//NumberOfMessages     .
//: . (handle) .

function msp_DestroyFrame(frame: msp_FRMHANDLE): msp_ERROR;
// 

function msp_AddMessage(frame: msp_FRMHANDLE; message: msp_MSGHANDLE; msggap: msp_WORD): msp_ERROR; cdecl;
//   
//fram  
//message  
//msggap         , 
//            
//    

function msp_AddMessages(frame: msp_FRMHANDLE; messages: Pmsp_MSGHANDLE; msggaps: Pmsp_WORD): msp_ERROR; cdecl;
//    
//fram  
//message -  () .
//			     msp_NOHANDLE
//msggaps -   .
//			.. NULL,  msggap   0

function msp_AddMessagesIndirect(frame: msp_FRMHANDLE; messages: PPmsp_MSGHANDLE; msggaps: Pmsp_WORD): msp_ERROR; cdecl;
//    
//fram  
//messages -    () 
//			     NULL
//msggaps -   .
//			.. NULL,  msggap   0

function msp_AddMessagesIndirect2(frame: msp_FRMHANDLE; indexes: Pmsp_WORD; messages: Pmsp_MSGHANDLE; msggaps: Pmsp_WORD): msp_ERROR; cdecl;
//    
//fram  
//indexes -      messages.
//			     0xFFFF
//message -  ()  ,   
//msggaps -   .
//			.. NULL,  msggap   0

function msp_VerifyFrameTime(frame: msp_FRMHANDLE; adjust: msp_BIT): msp_BIT; cdecl;
//    
//: 1 - , 0 -    
//					  
//adjust !=0 &&  == 0 -    
//fram  

function msp_GetFrameMessage(frame: msp_FRMHANDLE; entry: integer): msp_MSGHANDLE; cdecl;
//       
//fram  
//entry -    

function msp_ReplaceFrameMessage(frame: msp_FRMHANDLE; entry: integer; newmessage: msp_MSGHANDLE): msp_MSGHANDLE; cdecl;
//      
//    
//fram  
//entry -    
//newmessage -   

function msp_GetFrameProp(frame: msp_FRMHANDLE; prop: msp_BYTE): msp_WORD; cdecl;
//  
//fram  
//prop -  
//    
//msp_FD_FrameTime
//msp_FD_MessageCount
//msp_FD_MaxMessgeCount

function msp_SetFrameProp(frame: msp_FRMHANDLE; prop: msp_BYTE; value: msp_WORD):msp_ERROR; cdecl;
//  
//fram  
//prop -  
//  
//msp_FD_FrameTime

const
 msp_FD_FrameTime     =		0;
 msp_FD_MessageCount  =		1;
 msp_FD_MaxMessgeCount=	        2;

(***************************************************************
    ()      .
 ***************************************************************)

function msp_LoadFrame(frame: msp_FRMHANDLE; flags: integer): msp_ERROR; cdecl;
//        B.
//frame  
//flags    (msp_STK_A  msp_STK_B )
//msp_STK_A     A
//msp_STK_B     B
//msp_AUTOREPEAT     
//  
//   mspF_FRAME_AUTOREPEAT

//      msp_Command()

const msp_AUTOREPEAT	= $0002;

function msp_ResetFrame(frame: msp_FRMHANDLE):msp_ERROR; cdecl;
//        
//frame - 
// .. 

(***************************************************************
       
 ***************************************************************)

function msp_ReadFrameWord(frame: msp_FRMHANDLE; entry: integer; offset: msp_BYTE): msp_WORD; cdecl;
//    ,   .
//frame  
//entry      
//offset    ,   
//msp_FD_BSW    
//msp_FD_TIMETAG   
//msp_FD_MSGGAP      
//msp_FD_MSGADDR    
//:  .

function msp_BCRetrieveMessage(frame: msp_FRMHANDLE; entry: integer; var buffer: msp_Message): msp_ERROR; cdecl;
//       ,          .
//frame  
//entry      
//buffer     .      StatusWord1/2, loopback, BSW, timetag.
//:    0.
//  msp_RetrieveMessage,    BC

implementation

const NULL = Nil;

function  msp_BCtoRT(B: Pmsp_Message; RT,SA,wcnt: msp_BYTE; data: Pmsp_WORD; cw: msp_DWORD): Pmsp_Message;
begin Result := msp_FormatMessage(B, mspM_BCtoRT,RT, SA, 0, 0, wcnt, data, cw) end;
function  msp_RTtoBC(B: Pmsp_Message; RT, SA: msp_BYTE;wcnt: msp_BYTE;cw: msp_DWORD): Pmsp_Message;
begin Result := msp_FormatMessage(B, mspM_RTtoBC, RT, SA, 0, 0, wcnt, NULL, cw) end;
function  msp_RTtoRT(B: Pmsp_Message; RT, SA, RTR: msp_BYTE; SAR: msp_WORD; wcnt: msp_BYTE; cw: msp_DWORD): Pmsp_Message;
begin Result :=	msp_FormatMessage(B, mspM_RTtoRT, RT, SA, RTR, SAR, wcnt, NULL, cw) end;
function  msp_BCtoRT_bcst(B: Pmsp_Message; RT, SA : msp_BYTE; wcnt: msp_BYTE; data: Pmsp_WORD; cw: msp_DWORD): Pmsp_Message;
begin Result := msp_FormatMessage(B, mspM_BCtoRT_BROADCAST, 0,	SA,	0, 0, wcnt, data, cw) end;
function  msp_RTtoRT_bcst(B: Pmsp_Message; RT, SA: msp_BYTE; SAR: msp_WORD; wcnt: msp_BYTE; cw: msp_DWORD): Pmsp_Message;
begin Result := msp_FormatMessage(B, mspM_RTtoRT_BROADCAST, RT, SA, 0, SAR, wcnt, NULL, cw) end;
function  msp_Modecode(B: Pmsp_Message; RT, MC : msp_BYTE; cw: msp_DWORD): Pmsp_Message;
begin Result := msp_FormatMessage(B, mspM_MODECODE, RT, 0,  MC, 0, 0, NULL, cw) end;
function  msp_Modecode_data_tx(B: Pmsp_Message; RT, MC : msp_BYTE; cw: msp_DWORD): Pmsp_Message;
begin Result :=	msp_FormatMessage(B, mspM_MODECODE_DATA_TX, RT, 0, MC, 0, 0, NULL, cw) end;
function  msp_Modecode_data_rx(B: Pmsp_Message; RT, MC : msp_BYTE; MCD: msp_WORD; cw: msp_DWORD): Pmsp_Message;
begin Result := msp_FormatMessage(B, mspM_MODECODE_DATA_RX,		RT, 0,	MC, MCD, 0, NULL, cw) end;
function  msp_Modecode_bcst(B: Pmsp_Message; MC : msp_BYTE; cw: msp_DWORD): Pmsp_Message;
begin Result := msp_FormatMessage(B, mspM_MODECODE_BROADCAST,	0,  0,  MC, 0, 0, NULL, cw) end;
function  msp_Modecode_data_bcst(B: Pmsp_Message; MC : msp_BYTE; MCD: msp_WORD; cw: msp_DWORD): Pmsp_Message;
begin Result :=	msp_FormatMessage(B, mspM_MODECODE_DATA_BROADCAST,	0,  0,  MC, MCD, 0, NULL, cw) end;

function msp_DestroyMessage(msg: msp_MSGHANDLE): msp_ERROR;
begin Result := msp_DestroyHandle(msg) end;
function msp_DestroyFrame(frame: msp_FRMHANDLE): msp_ERROR;
begin Result := msp_DestroyHandle(frame) end;

function msp_ReadFrameWord(frame: msp_FRMHANDLE; entry: integer; offset: msp_BYTE): msp_WORD;
begin Result := msp_ReadStackWord(frame, entry, offset) end;

function msp_FormatMessage; external 'drtl3.dll' name 'msp_FormatMessage';
procedure msp_SetDefault_BCCW; external 'drtl3.dll' name 'msp_SetDefault_BCCW';
function msp_CreateMessage; external 'drtl3.dll' name 'msp_CreateMessage';
function msp_ReadBCMessage; external 'drtl3.dll' name 'msp_ReadBCMessage';
function msp_ReadMessageData; external 'drtl3.dll' name 'msp_ReadMessageData';
function msp_WriteMessageData; external 'drtl3.dll' name 'msp_WriteMessageData';
function msp_ReadMessageWord; external 'drtl3.dll' name 'msp_ReadMessageWord';
function msp_WriteMessageWord; external 'drtl3.dll' name 'msp_WriteMessageWord';
function msp_CreateFrame; external 'drtl3.dll' name 'msp_CreateFrame';
function msp_AddMessage; external 'drtl3.dll' name 'msp_AddMessage';
function msp_AddMessages; external 'drtl3.dll' name 'msp_AddMessages';
function msp_AddMessagesIndirect; external 'drtl3.dll' name 'msp_AddMessagesIndirect';
function msp_AddMessagesIndirect2; external 'drtl3.dll' name 'msp_AddMessagesIndirect2';
function msp_VerifyFrameTime; external 'drtl3.dll' name 'msp_VerifyFrameTime';
function msp_GetFrameMessage; external 'drtl3.dll' name 'msp_GetFrameMessage';
function msp_ReplaceFrameMessage; external 'drtl3.dll' name 'msp_ReplaceFrameMessage';
function msp_GetFrameProp; external 'drtl3.dll' name 'msp_GetFrameProp';
function msp_SetFrameProp; external 'drtl3.dll' name 'msp_SetFrameProp';
function msp_LoadFrame; external 'drtl3.dll' name 'msp_LoadFrame';
function msp_ResetFrame; external 'drtl3.dll' name 'msp_ResetFrame';
function msp_BCRetrieveMessage; external 'drtl3.dll' name 'msp_BCRetrieveMessage';

end.
