unit cache;

interface

uses access, config;

type
cash_TuneParam =
(
	//  
	cash_OptimaSwitchOn,
	cash_OptimaSwitchOff,
	cash_GetSwitch,
	//       
	cash_SaveExchangeOn,
	cash_SaveExchangeOff,
	cash_GetSaveExchange,
	//       
	cash_GlbErrOn,
	cash_GlbErrOff,
	cash_GetGlbErr,
	//  
	cash_DebugMark,
	//   
	cash_UpdateModeAuto,
	cash_UpdateModeSync,
	cash_GetUpdateMode
);

//    
function cash_ActivateDeviceCash(device:msp_DEVHANDLE): msp_ERROR; cdecl;

//    
function  cash_ReleaseDeviceCash(device:msp_DEVHANDLE):msp_ERROR; cdecl;

//       
function  cash_RefreshRamPreparation(device:msp_DEVHANDLE;
                    begin_mem: msp_WORD; size: integer):msp_ERROR;cdecl;

//     
function  cash_RefreshRamPreparationOnly(device:msp_DEVHANDLE;
                    begin_mem: msp_WORD; size: integer):msp_ERROR;cdecl;

const
cash_ALL_REGISTERS = $1F;

//    ()  
function  cash_RefreshRegPreparation(device:msp_DEVHANDLE;
                    RegNo: msp_BYTE):msp_ERROR;cdecl;
//  -  
// device -   
// RegNo  -   ,   cash_ALL_REGISTERS
//               

//    - msp_RetrieveMessage
function cash_RetrievePreparationLatch(stack: msp_STKHANDLE): msp_ERROR; cdecl;

//    
function  cash_WriteLatch(device:msp_DEVHANDLE):msp_ERROR;cdecl;

//    
function  cash_RefreshLatch(device:msp_DEVHANDLE):msp_ERROR;cdecl;

(*
	      .
	    (  ),
	   -    .
*)
//    
function cash_AutoExchangeOn(device: msp_DEVHANDLE): msp_ERROR; cdecl;
//    
function cash_AutoExchangeOff(device: msp_DEVHANDLE): msp_ERROR; cdecl;

// :    ?
function cash_IsDevIntoCash(device: msp_DEVHANDLE): msp_BOOL; cdecl;

//      26.20v2
function cash_AutoUpdateOn(device: msp_DEVHANDLE): msp_ERROR; cdecl;

//     26.20v2
function cash_AutoUpdateOff(device: msp_DEVHANDLE): msp_ERROR; cdecl;

(*
-   
*)
//   
function  cash_CashInterruption(device:msp_DEVHANDLE):msp_ERROR;cdecl;

//    
function  cash_CashWorkResumption(device:msp_DEVHANDLE):msp_ERROR;cdecl;

//   
function  cash_ForceClear(device:msp_DEVHANDLE):msp_ERROR;cdecl;

//  .
function  cash_Tune(parameter:cash_TuneParam):cash_TuneParam;cdecl;

implementation

function  cash_ActivateDeviceCash; external 'drtl3.dll' name 'cash_ActivateDeviceCash';
function  cash_ReleaseDeviceCash; external 'drtl3.dll' name 'cash_ReleaseDeviceCash';
function  cash_RefreshRamPreparation; external 'drtl3.dll' name 'cash_RefreshRamPreparation';
function  cash_WriteLatch; external 'drtl3.dll' name 'cash_WriteLatch';
function  cash_RefreshLatch; external 'drtl3.dll' name 'cash_RefreshLatch';
function  cash_CashInterruption; external 'drtl3.dll' name 'cash_CashInterruption';
function  cash_CashWorkResumption; external 'drtl3.dll' name 'cash_CashWorkResumption';
function  cash_ForceClear; external 'drtl3.dll' name 'cash_ForceClear';
function  cash_Tune; external 'drtl3.dll' name 'cash_Tune';
function  cash_RefreshRamPreparationOnly; external 'drtl3.dll' name 'cash_RefreshRamPreparationOnly';
function  cash_RefreshRegPreparation; external 'drtl3.dll' name 'cash_RefreshRegPreparation';
function cash_RetrievePreparationLatch; external 'drtl3.dll' name 'cash_RetrievePreparationLatch';
function cash_AutoExchangeOn; external 'drtl3.dll' name 'cash_AutoExchangeOn';
function cash_AutoExchangeOff; external 'drtl3.dll' name 'cash_AutoExchangeOff';
function cash_IsDevIntoCash; external 'drtl3.dll' name 'cash_IsDevIntoCash';
function cash_AutoUpdateOn; external 'drtl3.dll' name 'cash_AutoUpdateOn';
function cash_AutoUpdateOff; external 'drtl3.dll' name 'cash_AutoUpdateOff';

 end.
