unit config;

interface

uses access;

(***************************************************************
        
 ***************************************************************)

function msp_Open(i: integer): msp_DEVHANDLE; cdecl;
function msp_OpenEx(i, flags: integer): msp_DEVHANDLE; cdecl;
//    .
//    
//  msp_NOHANDLE.

function msp_Close(device: msp_DEVHANDLE): msp_ERROR; cdecl;
//    .

(***************************************************************
         
 ***************************************************************)

function msp_Open_Multi(device: msp_DEVHANDLE; i: integer): msp_DEVHANDLE; cdecl;
//   ()  
//device -  
//i -  
// device     msp_MODE_MRT
//
//     msp_MODE_RT
// .    - msp_Switch_Multi()


function msp_Switch_Multi(device: msp_DEVHANDLE; mode: msp_BIT): msp_ERROR; cdecl;
//       
//   .

(***************************************************************
        Flags / virtual registers data types
 ***************************************************************)

type
   msp_FLAGID = msp_DWORD;
   Pmsp_FLAGID = ^msp_FLAGID;
   msp_REGID = msp_DWORD;
   msp_REGVALUE =
     record
       reg:   msp_REGID;
       value: msp_WORD;
     end;
   Pmsp_REGVALUE = ^msp_REGVALUE;

(***************************************************************
        Flag functions
 ***************************************************************)

function msp_GetFlag(device: msp_DEVHANDLE; flag: msp_FLAGID): msp_BIT; cdecl;
//   .  0  1  
//   flag  device.

function msp_SetFlag(device: msp_DEVHANDLE; flag: msp_FLAGID; value: msp_BIT): msp_ERROR; cdecl;
//   .    flag
// device  0  value=0   1   .

function msp_SetFlagsIndirect( device: msp_DEVHANDLE; flags: Pmsp_FLAGID; value: msp_BIT): msp_ERROR; cdecl;
//     0  1  msp_SetFlag().
//:
//device  
//flags     mspF_XXXX;   ;     0
//value  ,      .
//    .

(***************************************************************
        Virtual register functions
 ***************************************************************)

function msp_GetVReg( device: msp_DEVHANDLE; reg: msp_REGID): msp_WORD; cdecl;
//   .
//:
//device  
//reg   
//:  .

function msp_SetVReg( device: msp_DEVHANDLE;  reg: msp_REGID; value: msp_WORD): msp_ERROR; cdecl;
//   .
//:
//device  
//reg   
//value   

function msp_SetVRegsIndirect(device: msp_DEVHANDLE ; regvalues: Pmsp_REGVALUE ): msp_ERROR; cdecl;
//    .
//:
//device  
//regvalue    -;   ;
//      0

(***************************************************************
            .
         C   .
              .
 ***************************************************************)

function MakeFLAGID(RR, BIT: integer): msp_FLAGID;
function StarFLAGID(RR, BIT: integer): msp_FLAGID;
function MakeREGID(RR, MASK: integer): msp_REGID;
function OffsREGID(RR, MASK, offs: integer): msp_REGID;
function MakeALIAS(RR: integer): msp_REGID;

const
//Common flags
mspF_CURRENT_AREA                   			= $00012000;
mspF_CURRENT_AREA_B                 			= mspF_CURRENT_AREA;
mspF_CURRENT_AREA_A                 			= $80012000;
mspF_LOWER_CLOCK_SELECT             			= $00098000;
mspF_DOUBLE_SAMPLE_FREQUENCY        			= $00090800;
mspF_EXPANDED_ZERO_CROSSING_ENABLED 			= mspF_DOUBLE_SAMPLE_FREQUENCY;
mspF_GAP_CHECK_ENABLED              			= $00090100;
mspF_256WORD_BOUNDARY_DISABLE       			= $00020400;
mspF_ENHANCED_MODE                  			= $00078000;
mspF_ENHANCED_CPU_ACCESS            			= $00184000;

//BC mode flags
mspF_MESSAGE_STOP_ON_ERROR          			= $00011000;
mspF_FRAME_STOP_ON_ERROR            			= $00010800;
mspF_STATUS_SET_STOP_ON_MESSSAGE    			= $00010400;
mspF_STATUS_SET_STOP_ON_FRAME       			= $00010200;
mspF_FRAME_AUTOREPEAT               			= $00010100;
mspF_EXTERNAL_TRIGGER_ENABLED       			= $00010080;
mspF_INTERNAL_TRIGGER_ENABLED       			= $00010040;
mspF_MESSAGE_GAP_TIMER_ENABLED      			= $00010020;
mspF_RETRY_ENABLED                  			= $00010010;
mspF_DOUBLE_RETRY                   			= $00010008;
mspF_BC_ENABLED                     			= $00010004;
mspF_BC_FRAME_IN_PROGRESS           			= $00010002;
mspF_BC_MESSAGE_IN_PROGRESS         			= $00010001;
mspF_EXPANDED_BC_CONTROL_WORD       			= $00081000;
mspF_BROADCAST_MASK_ENABLED         			= $00080800;
mspF_RETRY_IF_1553A_AND_MESSAGE_ERROR			= $00080400;
mspF_RETRY_IF_STATUS_SET            			= $00080200;
mspF_RETRY1_AT_ALT_BUS              			= $00080100;
mspF_RETRY2_AT_ALT_BUS              			= $00080080;
mspF_VALID_ERROR_BIT_NO_DATA        			= $00080040;
mspF_VALID_BUSY_BIT_NO_DATA         			= $00080020;

//lve RT, RT/MM, MM flags
mspF_INCREMENT_ON_EOM               			= $00182000;

//RT mode flags
mspF_NOT_ACCEPT_DYNAMIC_BUS_CONTROL			= $00010800;
mspF_ACCEPT_DYNAMIC_BUS_CONTROL    			= $80010800;
mspF_NOT_BUSY                      			= $00010400;
mspF_BUSY                          			= $80010400;
mspF_NOT_SERVICE_REQUEST           			= $00010200;
mspF_SERVICE_REQUEST               			= $80010200;
mspF_NOT_SUBSYSTEM_FLAG            			= $00010100;
mspF_SUBSYSTEM_FLAG                			= $80010100;
mspF_NOT_RTFLAG                    			= $00010080;
mspF_RTFLAG                        			= $80010080;
mspF_RT_MESSAGE_IN_PROGRESS        			= $00010001;

mspF_S10                           			= $00010800;
mspF_S09                           			= $00010400;
mspF_S08                           			= $00010200;
mspF_S07                           			= $00010100;
mspF_S06                           			= $00010080;
mspF_S05                           			= $00010040;
mspF_S04                           			= $00010020;
mspF_S03                           			= $00010010;
mspF_S02                           			= $00010008;
mspF_S01                           			= $00010004;
mspF_S00                           			= $00010002;
mspF_ALTSTATUS_MESSAGE_ERROR       			= mspF_S10;
mspF_ALTSTATUS_INSTRUMENTATION	    			= mspF_S09;
mspF_ALTSTATUS_SERVICE_REQUEST     			= mspF_S08;
mspF_ALTSTATUS_RESERVED_12	        			= mspF_S07;
mspF_ALTSTATUS_RESERVED_13	        			= mspF_S06;
mspF_ALTSTATUS_RESERVED_14	        			= mspF_S05;
mspF_ALTSTATUS_BROADCAST_COMMAND_RECEIVED			= mspF_S04;
mspF_ALTSTATUS_BUSY                			= mspF_S03;
mspF_ALTSTATUS_SUBSYSTEM_FLAG      			= mspF_S02;
mspF_ALTSTATUS_ACCEPT_DYNAMIC_BUS_CONTROL			= mspF_S01;
mspF_ALTSTATUS_TERMINAL_FLAG       			= mspF_S00;

mspF_MULTIRT_ENABLE                			= $00024000;
mspF_BUSY_BIT_LOOKUP_TABLE_ENABLE  			= $00022000;
mspF_DOUBLE_BUFFERING_ENABLE       			= $00021000;
mspF_OVERWRITE_INVALID_DATA        			= $00020800;
mspF_CLEAR_TIME_TAG_ON_SYNCHRONIZE 			= $00020040;
mspF_LOAD_TIME_TAG_ON_SYNCHRONIZE  			= $00020020;
mspF_CLEAR_SERVICE_REQUEST         			= $00020004;
mspF_ENHANCED_RT_MEMORY_MANAGEMENT 			= $00020002;
mspF_SEPARATE_BROADCAST_DATA       			= $00020001;
mspF_ILLEGALIZATION_DISABLED       			= $00070080;
mspF_OVERRIDE_MODE_CODE_BIT_ERROR  			= $00070040;
mspF_ALTERNATE_RT_STATUS_WORD_ENABLED			= $00070020;
mspF_ILLEGAL_RECEIVE_TRANSFER_DISABLE			= $00070010;
mspF_BUSY_RECEIVE_TRANSFER_DISABLE 			= $00070008;
mspF_RTF_WRAP_ENABLE               			= $00070004;
mspF_1553A_MODE_CODES_ENABLED      			= $00070002;
mspF_ENHANCED_MODE_CODE_HANDLING   			= $00070001;
mspF_EXTERNAL_BIT_WORD_ENABLE      			= $00088000;
mspF_INHIBIT_BIT_WORD_TRANSMIT_IF_BUSY			= $00084000;
mspF_MODE_CODE_OVERRIDE_BUSY       			= $00082000;
mspF_BROADCAST_DISABLED            			= $00090080;

//MT mode flags
mspF_MONITOR_TRIGGER_ENABLED	      			= $00010800;
mspF_START_ON_TRIGGER              			= $00010400;
mspF_STOP_ON_TRIGGER               			= $00010200;
//mspF_EXTERNAL_TRIGGER_ENABLED	    			= $00010080;
mspF_MONITOR_ENABLED               			= $00010004;
mspF_MONITOR_TRIGGERED             			= $00010002;
mspF_MONITOR_ACTIVE                			= $00010001;
//mspF_1553A_MODE_CODES_ENABLED	    			= $00070002;
mspF_MONITOR_TAG_GAP_OPTION        			= $00080010;
//mspF_BROADCAST_DISABLED            			= $00090080;

//Interrupt control flags
mspF_ENHANCED_INTERRUPTS           			= $00028000;
mspF_INTERRUPT_STATUS_AUTO_CLEAR   			= $00020010;
mspF_LEVEL_INTERRUPTS              			= $00020008;
mspF_PULSE_INTERRUPTS              			= $80020008;

//External config flags
mspFE_BUS_TRANSPARENT_MODE	   			= $00200001;
mspFE_BUS_BUFFERED_MODE		   			= $80200001;
mspFE_BUS_BUFFERED_WORD		   			= $00200002;
mspFE_BUS_BUFFERED_BYTE		   			= $80200002;
mspFE_POLARITY                     			= $00200004;
mspFE_NONZEROWAIT                  			= $00200008;
mspFE_NOT_ZEROWAIT                 			= mspFE_NONZEROWAIT;
mspFE_ZEROWAIT                     			= $80200008;
mspFE_ADDR_LAT                     			= $00200010;
mspFE_TRIGGER_SEL                  			= $00200020;
mspFE_EXT_TRIG                     			= $00200080;
mspFE_NOT_SSFLAG                   			= $00200080;
mspFE_SSFLAG                       			= $80200080;
mspFE_NOT_INCMD                    			= $00200100;
mspFE_INCMD                        			= $80200100;

//Software flags
mspFS_RT_SET_BUSY_FOR_BUFFER       			= $00FF0001;
mspFS_RT_ILLEGALIZE_FOR_BUFFER     			= $00FF0002;
mspFS_RT_SAFE_RETRIEVE		          			= $00FF0004;
mspFS_MRT_REGISTER_OVERRIDE	      			= $00FF0008;
mspFS_MRT_REGISTER_NOT_OVERRIDE	  			= $80FF0008;
mspFS_DISPATCH_KEEP_INTERRUPT	    			= $00FF0020;

//Virtual registers
mspR_RT_STATUS_WORD                			= $000EFFFF;
mspR_TIME_TAG_RESOLUTION           			= $00020380;
          //:
          msp_TIME_TAG_RESOLUTION_64us            = $0000;
          msp_TIME_TAG_RESOLUTION_32us            = $0080;
          msp_TIME_TAG_RESOLUTION_16us            = $0100;
          msp_TIME_TAG_RESOLUTION_8us             = $0180;
          msp_TIME_TAG_RESOLUTION_4us             = $0200;
          msp_TIME_TAG_RESOLUTION_2us             = $0280;
          msp_TIME_TAG_RESOLUTION_TEST_MODE       = $0300;
          msp_TIME_TAG_RESOLUTION_EXT_CLOCK       = $0380;
mspR_COMMAND_STACK_POINTER         			= $0003FFFF;
mspR_CONTROL_WORD                  			= $0004FFFF;
mspR_TIME_TAG                      			= $0005FFFF;
mspR_COMMAND_STACK_SIZE            			= $00076000;
//  /.
        //:
          msp_STACK_SIZE_64			  = $0000;
          msp_STACK_SIZE_128       = $2000;
          msp_STACK_SIZE_256       = $4000;
          msp_STACK_SIZE_512       = $6000;
        //(   )
mspR_MT_COMMAND_STACK_SIZE         			= $00071800;
//  .
        //:
          msp_MT_CSTACK_SIZE_64    = $0000;
          msp_MT_CSTACK_SIZE_256   = $0800;
          msp_MT_CSTACK_SIZE_1024  = $1000;
          msp_MT_CSTACK_SIZE_4096  = $1800;
        //(   )
mspR_MT_DATA_STACK_SIZE            			= $00070700;
//  .
        //:
          msp_MT_DSTACK_SIZE_64K   = $0000;
          msp_MT_DSTACK_SIZE_32K   = $0100;
          msp_MT_DSTACK_SIZE_16K   = $0200;
          msp_MT_DSTACK_SIZE_8K    = $0300;
          msp_MT_DSTACK_SIZE_4K    = $0400;
          msp_MT_DSTACK_SIZE_2K    = $0500;
          msp_MT_DSTACK_SIZE_1K    = $0600;
          msp_MT_DSTACK_SIZE_512   = $0700;
        //(   )
mspR_RESPONSE_TIMEOUT              			= $00090600;
        //:
          msp_RESPONSE_TIMEOUT_18us5   = $0000;
          msp_RESPONSE_TIMEOUT_22us5   = $0200;
          msp_RESPONSE_TIMEOUT_50us5   = $0400;
          msp_RESPONSE_TIMEOUT_130us   = $0600;
mspR_DATA_STACK_ADDRESS            			= $000AFFFF;
mspR_BC_FRAME_TIME_REMAINING	      			= $000BFFFF;
mspR_BC_MESSAGE_TIME_REMAINING	    			= $000CFFFF;
mspR_BC_FRAME_TIME                 			= $000DFFFF;
mspR_RT_LAST_COMMAND               			= mspR_BC_FRAME_TIME;
mspR_MT_TRIGGER                    			= mspR_BC_FRAME_TIME;
//mspR_RT_STATUS_WORD                			= $000EFFFF;
mspR_RT_BIT_WORD                   			= $000FFFFF;
mspR_INTERRUPT_MASK                			= $0000FFFF;
mspR_INTERRUPT_STATUS              			= $0006FFFF;
        //mspR_INTERRUPT_MASK  mspR_INTERRUPT_STATUS -  .
        // :
          mspM_MASTER_INTERRUPT                   = $8000; //  mspR_INTERRUPT_STATUS
          mspM_RAM_PARITY_ERROR                   = $4000;
          mspM_TRANSMITTER_TIMEOUT                = $2000;
          mspM_COMMAND_STACK_ROLLOVER             = $1000;
          mspM_MT_COMMAND_STACK_ROLLOVER          = $0800;
          mspM_MT_DATA_STACK_ROLLOVER             = $0400;
          mspM_HANDSHAKE_FAILURE                  = $0200;
          mspM_BC_RETRY                           = $0100;
          mspM_RT_ADDRESS_PARITY_ERROR            = $0080;
          mspM_TIME_TAG_ROLLOVER                  = $0040;
          mspM_RT_CIRCULAR_BUFFER_ROLLOVER        = $0020;
          mspM_BCCW_EOM                           = $0010;
          mspM_SACW_EOM                           = $0010;
          mspM_BC_EOF                             = $0008;
          mspM_FORMAT_ERROR                       = $0004;
          mspM_BC_STATUS_SET                      = $0002;
          mspM_RT_MODE_CODE                       = $0002;
          mspM_MT_PATTERN_TRIGGER                 = $0002;
          mspM_EOM                                = $0001;
mspR_RT_ADDRESS                    			= $1009003E;
// ^ RO; autoshift
mspRE_RT_ADDRESS                   			= $0021001F;
//Virtual aliases to other physical registers
//NOT recommended for use programmatically,
//BUT usefull for graphic shell trics
mspR_CONFIG1                       			= $0001FFFF;
mspR_CONFIG2                       			= $0002FFFF;
mspR_COMMAND                       			= $0003FFFF;
mspR_CONFIG3                       			= $0007FFFF;
mspR_CONFIG4                       			= $0008FFFF;
mspR_CONFIG5                       			= $0009FFFF;
mspRE_EXTERNAL_CONFIG		          			= $0020FFFF;

//MRT mode flags & vregisters
mspR_MRT_ADDRESS                   			= $0010FFFF;
mspR_MRT_CONFIG1                   			= $0011FFFF;
	mspF_MRT_S10               			= $00110800;
	mspF_MRT_S09               			= $00110400;
	mspF_MRT_S08               			= $00110200;
	mspF_MRT_S07               			= $00110100;
	mspF_MRT_S06               			= $00110080;
	mspF_MRT_S05               			= $00110040;
	mspF_MRT_S04               			= $00110020;
	mspF_MRT_S03               			= $00110010;
	mspF_MRT_S02               			= $00110008;
	mspF_MRT_S01               			= $00110004;
	mspF_MRT_S00               			= $00110002;
	mspF_MRT_ALTSTATUS_MESSAGE_ERROR			= mspF_MRT_S10;
	mspF_MRT_ALTSTATUS_INSTRUMENTATION			= mspF_MRT_S09;
	mspF_MRT_ALTSTATUS_SERVICE_REQUEST			= mspF_MRT_S08;
	mspF_MRT_ALTSTATUS_RESERVED_12			= mspF_MRT_S07;
	mspF_MRT_ALTSTATUS_RESERVED_13			= mspF_MRT_S06;
	mspF_MRT_ALTSTATUS_RESERVED_14			= mspF_MRT_S05;
	mspF_MRT_ALTSTATUS_BROADCAST_COMMAND_RECEIVED			= mspF_MRT_S04;
	mspF_MRT_ALTSTATUS_BUSY       			= mspF_MRT_S03;
	mspF_MRT_ALTSTATUS_SUBSYSTEM_FLAG			= mspF_MRT_S02;
	mspF_MRT_ALTSTATUS_ACCEPT_DYNAMIC_BUS_CONTROL			= mspF_MRT_S01;
	mspF_MRT_ALTSTATUS_TERMINAL_FLAG			= mspF_MRT_S00;
	mspF_MRT_NOT_ACCEPT_DYNAMIC_BUS_CONTROL			= $00110800;
	mspF_MRT_ACCEPT_DYNAMIC_BUS_CONTROL			= $80110800;
	mspF_MRT_BUSY              			= $80110400;
	mspF_MRT_NOT_SERVICE_REQUEST			= $00110200;
	mspF_MRT_SERVICE_REQUEST   			= $80110200;
	mspF_MRT_NOT_SUBSYSTEM_FLAG			= $00110100;
	mspF_MRT_SUBSYSTEM_FLAG    			= $80110100;
	mspF_MRT_NOT_RTFLAG        			= $00110080;
	mspF_MRT_RTFLAG            			= $80110080;
 mspR_MRT_STATUS            			= $0015FFFF;
	mspF_MRT_MESSAGE_IN_PROGRESS			= $00158000;
	mspR_MRT_ISR_FIFO_COUNTER  			= $0015000F;
	mspR_MRT_ACTIVE_RT         			= $80151F00;
mspR_MRT_INTERRUPT_STATUS          			= $0016FFFF;
      mspM_MRT_TRANSMITTER_TIMEOUT        = $2000;
      mspM_MRT_COMMAND_STACK_ROLLOVER     = $1000;
      mspM_MRT_HANDSHAKE_FAILURE          = $0200;
      mspM_MRT_TIME_TAG_ROLLOVER          = $0040;
      mspM_MRT_RT_CIRCULAR_BUFFER_ROLLOVER= $0020;
      mspM_MRT_SACW_EOM                   = $0010;
      mspM_MRT_FORMAT_ERROR               = $0004;
      mspM_MRT_RT_MODE_CODE               = $0002;
      mspM_MRT_EOM                        = $0001;
mspR_MRT_ISR_RT_ADDRESS            			= $0016FF00;
mspR_MRT_COMMAND_WORD              			= $001DFFFF;
mspR_MRT_STATUS_WORD               			= $001EFFFF;
mspR_SOFTWARE2_MRT_ISR             			= $00FEFFFF;

///////////////////////////////    /////////////////////////////////////////
//  
mspR_WG_DATA_STACK_POINTER	        			= $0003FFFF;
mspR_WG_INITIAL_DATA_STACK_POINTER 			= $0004FFFF;
// 
mspF_GENERATOR_ACTIVE              			= $00010008;

(***************************************************************
             
 ***************************************************************)
{.$Define config_reg_gen}
{$IfDef config_reg_gen}
procedure config_reg_gen;
{$EndIf}

(***************************************************************
        General configuration functions
 ***************************************************************)

function msp_SelectMode(device: msp_DEVHANDLE; mode: msp_MODE): msp_ERROR; cdecl;
//   .
//:
//device  
//mode   ( )   msp_MODE_XX, msp_SWITCH_XX

function msp_Configure(device: msp_DEVHANDLE; mode: msp_MODE; flags: Pmsp_FLAGID;
                       regvalues: Pmsp_REGVALUE): msp_ERROR; cdecl;
//  .
//   msp_SelectMode(),
//msp_SetFlagsIndirect(), msp_SetVRegsIndirect().
//:
//device  
//mode   ( )  
//flags   ,   1. .. NULL
//regvalues       , .. NULL

(***************************************************************
        Command functions
 ***************************************************************)

function msp_Command(device: msp_DEVHANDLE; command: msp_WORD): msp_ERROR; cdecl;
// . (   )
//:
//device  
//command   . bitmapped: mspC_XXXX

const
mspC_RESET =                     $0001;
mspC_START =                     $0002;
mspC_INTERRUPT_RESET =           $0004;
mspC_TIME_TAG_RESET =            $0008;
mspC_TIME_TAG_TEST_CLOCK =       $0010;
mspC_STOP_ON_FRAME       =       $0020;
mspC_STOP_ON_MESSAGE     =       $0040;

function msp_Start(device: msp_DEVHANDLE): msp_ERROR;
function msp_Reset(device: msp_DEVHANDLE): msp_ERROR;
function msp_ResetInterrupt(device: msp_DEVHANDLE): msp_ERROR;
function msp_ResetTimeTag(device: msp_DEVHANDLE): msp_ERROR;
function msp_TimeTagTestClock(device: msp_DEVHANDLE): msp_ERROR;
function msp_StopOnFrame(device: msp_DEVHANDLE): msp_ERROR;
function msp_StopOnMessage(device: msp_DEVHANDLE): msp_ERROR;

(***************************************************************
        Common constants & data types
 ***************************************************************)

//    
type
  msp_RAMHANDLE = msp_HANDLE;

const
//  
  msp_STK_A  =     0;
  msp_STK_B  =     1;
  msp_STK_mask =   1;

// .
  msp_DIR_RX = 0;
  msp_DIR_TX = 1;
  msp_DIR_BCST = 2;  //  RT
  msp_DIR2_mask = 1;
  msp_DIR3_mask = 3;

(***************************************************************
        1553 messages
 ***************************************************************)

// 1553 -     
//     
// ,   
type
  msp_Message =
    record
        type_:          msp_WORD;  // <=> 
        dataWordCount:  msp_WORD ; // <-> 
        bccw:           msp_WORD;  // <=>   BC
        (*-----*)
        CmdWord1: msp_WORD; // <=> 
        CmdWord2: msp_WORD; // <=> RT-to-RT
        Data: array[0..31] of msp_WORD; // <=> 
        (*-----*)
        StatusWord1: msp_WORD; // =>   msp_RetrieveMessage(), msp_ReadBCMessage
        StatusWord2: msp_WORD; // => -"- + RT-to-RT
        loopback:    msp_WORD; // => -"-   BC
        (*-----*)
        bsw:     msp_WORD; (*Block Status Word*) // =>   msp_RetrieveMessage()
        timetag: msp_WORD; // =>   msp_RetrieveMessage()
		//  
                present, transmit, check,role: msp_BYTE;
    end;
  Pmsp_Message = ^msp_Message;

const
//     type
mspM_fRECEIVE = 1;
mspM_fTRANSMIT = 2;
mspM_fMODECODE = 4;
mspM_fBROADCAST = 8;
mspM_EXTENDED =	$10;

//    type
mspM_BCtoRT = mspM_fRECEIVE;
mspM_RTtoBC = mspM_fTRANSMIT;
mspM_RTtoRT = mspM_fRECEIVE + mspM_fTRANSMIT;
mspM_BCtoRT_BROADCAST = mspM_fRECEIVE + mspM_fBROADCAST;
mspM_RTtoRT_BROADCAST = mspM_fRECEIVE + mspM_fTRANSMIT + mspM_fBROADCAST;
mspM_MODECODE = mspM_fMODECODE;
mspM_MODECODE_DATA_TX = mspM_fMODECODE + mspM_fTRANSMIT;
mspM_MODECODE_DATA_RX = mspM_fMODECODE + mspM_fRECEIVE;
mspM_MODECODE_BROADCAST = mspM_fMODECODE + mspM_fBROADCAST;
mspM_MODECODE_DATA_BROADCAST = mspM_fMODECODE + mspM_fRECEIVE + mspM_fBROADCAST;
// 
mspM_UNDEFINED = 0;

//Mode codes
mspMC_DYNAMIC_BUS_CONTROL                       = $00;
mspMC_SYNCHRONIZE                               = $01;
mspMC_TRANSMIT_STATUS_WORD                      = $02;
mspMC_INITIATE_SELF_TEST                        = $03;
mspMC_TRANSMITTER_SHUTDOWN                      = $04;
mspMC_OVERRIDE_TRANSMITTER_SHUTDOWN             = $05;
mspMC_INHIBIT_TFLAG                             = $06;
mspMC_OVERRIDE_INHIBIT_TFLAG                    = $07;
mspMC_RESET_REMOTE_TERMINAL                     = $08;
mspMC_RESET_RT                                  = mspMC_RESET_REMOTE_TERMINAL;
mspMC_TRANSMIT_VECTOR_WORD                      = $10;
mspMC_SYNCHRONIZE_WITH_DATA                     = $11;
mspMC_TRANSMIT_LAST_COMMAND                     = $12;
mspMC_TRANSMIT_BIT_WORD                         = $13;
mspMC_SELECTED_TRANSMITTER_SHUTDOWN             = $14;
mspMC_OVERRIDE_SELECTED_TRANSMITTER_SHUTDOWN    = $15;

//Status decode
msp_STATUS_RTADD_MASK					= $F800;
msp_STATUS_MESSAGE_ERROR				= $0400;
msp_STATUS_INSTRUMENTATION				= $0200;
msp_STATUS_SERVICE_REQUEST				= $0100;
msp_STATUS_RESERVED_12				= $0080;
msp_STATUS_RESERVED_13				= $0040;
msp_STATUS_RESERVED_14				= $0020;
msp_STATUS_BROADCAST_COMMAND_RECEIVED   = $0010;
msp_STATUS_BUSY							= $0008;
msp_STATUS_SUBSYSTEM_FLAG				= $0004;
msp_STATUS_DYNAMIC_BUS_CONTROL_ACCEPTED = $0002;
msp_STATUS_TERMINAL_FLAG				= $0001;

(***************************************************************
        Command word encoding & decoding; Status decoding
 ***************************************************************)

function FormatCommandWord(DIR: msp_DIR; RT: msp_BYTE; SA: msp_BYTE; WCNT: msp_BYTE ): msp_WORD;
procedure ParseCommandWord(CMD: msp_WORD; var TX: msp_DIR; var RT, SA, WCNT: msp_BYTE);
procedure CorrectWCNT(var WCNT: msp_BYTE);
function StatusRTADD(CMD: msp_WORD): msp_BYTE;

(***************************************************************
        Constants & data types for stacks & frames
 ***************************************************************)

type
// 
msp_STKHANDLE = msp_RAMHANDLE;
//!!: msp_FRMHANDLE (bc.h) -   msp_STKHANDLE

// () 
msp_MESSAGE_STATUS = (msp_MESSAGE_WAITING, msp_MESSAGE_IN_PROGRESS, msp_MESSAGE_COMPLETED);

const

//  (FW),  (SW)
msp_FW_BSW      = 0;
msp_FW_TIMETAG  = 1;
msp_FW_MSGGAP   = 2;
msp_FW_MSGADDR  = 3;
msp_SW_BSW      = 0;
msp_SW_TIMETAG  = 1;
msp_SW_DBP      = 2;
msp_SW_CMD      = 3;

// ""  
msp_LAST_RECEIVED =      $FFFF;
msp_NEXT_MESSAGE  =      $FFFE;
msp_SAME_MESSAGE  =      $FFFD;

//Block Status Word bits
msp_BSW_EOM =                                    (1 shl 15);
msp_BSW_SOM =                                    (1 shl 14);
msp_BSW_CHANNEL_B =                              (1 shl 13);
msp_BSW_ERROR_FLAG =                             (1 shl 12);
msp_BSW_FORMAT_ERROR =		     		               (1 shl 10);
msp_BSW_NO_RESPONSE_TIMEOUT =                    (1 shl 9);

msp_BSW_BC_EOM              =                    (1 shl 15);
msp_BSW_BC_SOM              =                    (1 shl 14);
msp_BSW_BC_CHANNEL_B        =                    (1 shl 13);
msp_BSW_BC_ERROR_FLAG       =                    (1 shl 12);
msp_BSW_BC_STATUS_SET       =                    (1 shl 11);
msp_BSW_BC_FORMAT_ERROR     =                    (1 shl 10);
msp_BSW_BC_NO_RESPONSE_TIMEOUT =                 (1 shl 9);
msp_BSW_BC_LOOP_TEST_FAIL      =                 (1 shl 8);
msp_BSW_BC_MASKED_STATUS_SET   =                 (1 shl 7);
msp_BSW_BC_DOUBLE_RETRY        =                 (1 shl 6);
msp_BSW_BC_SINGLE_RETRY        =                 (1 shl 5);
msp_BSW_BC_GOOD_DATA_BLOCK_TRANSFER =            (1 shl 4);
msp_BSW_BC_STATUS_RESPONSE_ERROR    =            (1 shl 3);
msp_BSW_BC_WORD_COUNT_ERROR         =            (1 shl 2);
msp_BSW_BC_INCORRECT_SYNC_TYPE      =            (1 shl 1);
msp_BSW_BC_INVALID_WORD             =             1;

msp_BSW_RT_EOM                      =            (1 shl 15);
msp_BSW_RT_SOM                      =            (1 shl 14);
msp_BSW_RT_CHANNEL_B                =            (1 shl 13);
msp_BSW_RT_ERROR_FLAG               =            (1 shl 12);
msp_BSW_RT_RT_TO_RT                 =            (1 shl 11);
msp_BSW_RT_FORMAT_ERROR             =            (1 shl 10);
msp_BSW_RT_NO_RESPONSE_TIMEOUT      =            (1 shl 9);
msp_BSW_RT_LOOP_TEST_FAIL           =            (1 shl 8);
msp_BSW_RT_CIRCULAR_BUFFER_ROLLOVER =            (1 shl 7);
msp_BSW_RT_ILLEGAL_COMMAND_WORD     =            (1 shl 6);
msp_BSW_RT_WORD_COUNT_ERROR         =            (1 shl 5);
msp_BSW_RT_INCORRECT_DATA_SYNC      =            (1 shl 4);
msp_BSW_RT_INVALID_WORD             =            (1 shl 3);
msp_BSW_RT_STATUS_RESPONSE_ERROR    =            (1 shl 2);
msp_BSW_RT_SECOND_COMMAND_ERROR     =            (1 shl 1);
msp_BSW_RT_COMMAND_WORD_ERROR       =            1;

msp_BSW_MM_EOM                      =            (1 shl 15);
msp_BSW_MM_SOM                      =            (1 shl 14);
msp_BSW_MM_CHANNEL_B                =            (1 shl 13);
msp_BSW_MM_ERROR_FLAG               =            (1 shl 12);
msp_BSW_MM_RT_TO_RT                 =            (1 shl 11);
msp_BSW_MM_FORMAT_ERROR             =            (1 shl 10);
msp_BSW_MM_NO_RESPONSE_TIMEOUT	    =		 (1 shl 9);
msp_BSW_MM_GOOD_DATA_BLOCK_TRANSFER =            (1 shl 8);
msp_BSW_MM_DATA_STACK_ROLLOVER      =            (1 shl 7);
                                                      (*Bit 6 is reserved*)
msp_BSW_MM_WORD_COUNT_ERROR         =            (1 shl 5);
msp_BSW_MM_INCORRECT_DATA_SYNC      =            (1 shl 4);
msp_BSW_MM_INVALID_WORD             =            (1 shl 3);
msp_BSW_MM_STATUS_RESPONSE_ERROR    =            (1 shl 2);
msp_BSW_MM_SECOND_COMMAND_ERROR     =            (1 shl 1);
msp_BSW_MM_COMMAND_WORD_ERROR       =            1;

(***************************************************************
    Polymorphic functions for stacks & frames
 ***************************************************************)

function msp_RetrieveMessage(stack: msp_STKHANDLE; entry: integer; var buffer: msp_Message): msp_ERROR; cdecl;
//       ,          /
//stack  ;  RT-, MT-  BC-
//entry      
//                       ""    
//                      msp_NEXT_MESSAGE -   (,   )
//                                                                  
//                                                                 
//                      msp_SAME_MESSAGE -   ,     
//                      msp_LAST_RECEIVED - ,     
//buffer     .      StatusWord1/2, loopback, BSW, timetag.

function msp_ReadStackWord(stack: msp_STKHANDLE; entry: integer; offset: msp_BYTE):msp_WORD; cdecl;
//    ,   /.
//stack   (RT,MT)   (BC)
//entry      ,   
//      msp_NEXT_MESSAGE -  
//                                              
//      msp_SAME_MESSAGE -   ,       msp_RetrieveMessage
//      msp_LAST_RECEIVED - ,     
//offset    ,    msp_SD_XXXX  msp_FD_XXXX
//      msp_SW_BSW    
//      msp_SW_TIMETAG   
//      msp_SW_DBP    
//      msp_SW_CMD    1553
//      msp_FW_BSW     (BC)
//      msp_FW_TIMETAG    (BC)
//      msp_FW_MSGGAP       (BC)
//      msp_FW_MSGADDR     (BC)

function msp_GetMessageStatus(stack:msp_STKHANDLE; entry:integer): msp_MESSAGE_STATUS; cdecl;
//  .
//stack   (RT,MT)   (BC)
//entry      ,   
//      msp_NEXT_MESSAGE -  
//                                              
//      msp_SAME_MESSAGE -   ,       msp_RetrieveMessage
//      msp_LAST_RECEIVED - ,     
//:   :
//msp_MST_WAITING
//msp_MST_IN_PROGRESS
//msp_MST_COMPLETED

function msp_GetCurrentEntry(stack: msp_STKHANDLE; option: integer): msp_WORD; cdecl;
//    ()
//stack  ;  RT-, MT-  BC-
//   ""
//option -   
//      msp_NEXT_MESSAGE -  
//                                              
//      msp_SAME_MESSAGE -   ,       msp_RetrieveMessage
//      msp_LAST_RECEIVED - ,     
//:  

function msp_ResetStack(stack: msp_STKHANDLE; msgindex: integer): msp_ERROR; cdecl;
//   
//     RT  MT
//:
//stack - 
//msgindex -   
//   

(***************************************************************
        Ram object functions:. applicable to all.
 ***************************************************************)

function msp_AddressOf(handle:msp_RAMHANDLE):msp_WORD; cdecl;
function msp_SizeOf(handle:msp_RAMHANDLE):msp_WORD; cdecl;
function msp_HandleFrom(device:msp_DEVHANDLE ; Address:msp_WORD ):msp_RAMHANDLE; cdecl; //SLOW!
//      

function msp_DeviceOf(handle:msp_RAMHANDLE):msp_DEVHANDLE ; cdecl;
//   

function msp_FillHandle(handle: msp_RAMHANDLE; data: msp_WORD): msp_ERROR;
//  .

function msp_DestroyHandle(handle:msp_RAMHANDLE):msp_ERROR; cdecl;
//        

(***************************************************************
        Ram control
 ***************************************************************)

function msp_RamTotal(device: msp_DEVHANDLE):msp_DWORD; cdecl;
function msp_RamFree(device: msp_DEVHANDLE):msp_DWORD; cdecl; //SLOW!
//   

function msp_EraseRam(device: msp_DEVHANDLE):msp_ERROR; cdecl;
//  
// :   .
//                              Handle's     -  
//     
//SelectMode()  Configure()    ,
//    msp_SWITCH_KEEP_RAM

function msp_FixedRam(device: msp_DEVHANDLE; command:msp_BYTE; areas:msp_WORD):msp_ERROR; cdecl;
//    
//device - 
//command - ,   
//      msp_CARE_FRAM -     
//                                      ( msp_Open()     "CARE")
//      msp_DONT_CARE_FRAM - !msp_CARE_FRAM
//      msp_RESERVE_FRAM -    
//      msp_FREE_FRAM -     
//      msp_CHECK_FRAM -   
//                                 ;
//                               areas -  
//areas - ,    ,   msp_FRAM_XXXX

const
msp_CARE_FRAM =          1;
msp_DONT_CARE_FRAM =     2;
msp_RESERVE_FRAM   =     3;
msp_FREE_FRAM      =     4;
msp_CHECK_FRAM     =     5;

msp_FRAM_POINTERS               = $0001;
msp_FRAM_MM_LOOKUP              = $0002;
msp_FRAM_LOOKUP_A               = $0004;
msp_FRAM_LOOKUP_B               = $0008;
msp_FRAM_MODECODE_INT		= $0010;
msp_FRAM_MODECODE_DATA		= $0020;
msp_FRAM_BUSY                   = $0040;
msp_FRAM_ILLEGALIZATION		= $0080;
msp_FRAM_DUMMY			= $0100;

//Fixed RAM locations (within msp_FRAM_POINTERS)
msp_BC_STACK_POINTER_A          = $0100;
msp_BC_STACK_COUNTER_A          = $0101;
msp_BC_INITIAL_STACK_POINTER_A	= $0102;
msp_BC_INITIAL_STACK_COUNTER_A  = $0103;
msp_RT_STACK_POINTER_A          = $0100;
msp_MM_STACK_POINTER_A          = $0102;
msp_MM_DATA_STACK_POINTER_A     = $0103;
msp_WM_INITIAL_STACK_POINTER_A  = $0100;
msp_BC_STACK_POINTER_B          = $0104;
msp_BC_STACK_COUNTER_B          = $0105;
msp_BC_INITIAL_STACK_POINTER_B  = $0106;
msp_BC_INITIAL_STACK_COUNTER_B  = $0107;
msp_RT_STACK_POINTER_B          = $0104;
msp_MM_STACK_POINTER_B          = $0106;
msp_MM_DATA_STACK_POINTER_B     = $0107;
msp_WM_INITIAL_STACK_POINTER_B  = $0104;
msp_MRT_ACTIVITY_VECTOR_1		= $0102;
msp_MRT_ACTIVITY_VECTOR_2		= $0103;


(***************************************************************
        Common RT/MT configuration parameters
 ***************************************************************)

type
  msp_rangeCmdWords =
  record
    rangeCmdWord0, rangeCmdWord1: msp_WORD
  end;
//  ,   
// msp_SetBusySA[Indirect], msp_MTSelectMessages[Indirect]
// msp_SetIllegalCommands[Indirect]
// - .   
  Pmsp_rangeCmdWords = ^msp_rangeCmdWords;

//    :
const
  msp_RANGE_ALL       = $FF;
  msp_RANGE_DIR_TX    = msp_DIR_TX;
  msp_RANGE_DIR_RX    = msp_DIR_RX;
  msp_RANGE_RT_OWN    = 0;
  msp_RANGE_RT_BCST   = 31;

(*     
         
     .    -  .    
    msp_rangeCmdWords,    
      .
   msp_rangeCmdBUSY()     msp_SetBusySA[Indirect],
   msp_rangeCmdILL() -   msp_SetIllegalCommands[Indirect],
   msp_rangeCmdMT() -   msp_SelectMessages[Indirect],
   msp_rangeAll() -      
     .
*)

function msp_rangeCmdBUSY(DIR: msp_DIR; RT: msp_WORD;
    SA0, SA1: msp_WORD): msp_rangeCmdWords;
function msp_rangeCmdILL(DIR: msp_DIR; RT: msp_WORD;
    SA0, SA1, WC0, WC1: msp_WORD): msp_rangeCmdWords;
//DIR -  ; : msp_RANGE_DIR_TX,
//              msp_RANGE_DIR_RX, msp_RANGE_ALL
//RT -  / ,
//              : msp_RANGE_RT_OWN, msp_RANGE_RT_BCST, msp_RANGE_ALL
//SA0, SA1 -      ,
//              : 0-31,    1 ,   
//WC0, WC1 ( msp_rangeCmdWC())
//              -        

function msp_rangeCmdMT(DIR: msp_DIR; RT0, RT1: msp_WORD;
    SA0, SA1: msp_WORD): msp_rangeCmdWords;
//DIR -  ; : msp_RANGE_DIR_TX,
//              msp_RANGE_DIR_RX, msp_RANGE_ALL
//RT0, RT1 -       ,
//              : 0-31,    1 ,   
//SA0, SA1 -      ,
//              : 0-31,    1 ,   

function msp_rangeAll: msp_rangeCmdWords;

const
msp_ENABLE  = 1;
msp_DISABLE = 0;

implementation

function MakeFLAGID(RR, BIT: integer): msp_FLAGID;
begin Result := (RR shl 16) or (1 shl BIT)
end;
function StarFLAGID(RR, BIT: integer): msp_FLAGID;
begin Result := MakeFLAGID(RR, BIT) xor $80000000
end;
function MakeREGID(RR, MASK: integer): msp_REGID;
begin Result := (RR shl 16) or MASK
end;
function OffsREGID(RR, MASK, offs: integer): msp_REGID;
begin Result := (offs shl 28) or (RR shl 16) or MASK
end;
function MakeALIAS(RR: integer): msp_REGID;
begin Result := (RR shl 16) or $FFFF
end;

{$IfDef config_reg_gen}
procedure config_reg_gen;
    function toHex(value: msp_DWORD): String;
    const
     digits: array [0..15] of Char =
     ('0', '1', '2', '3', '4', '5', '6', '7',
      '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
    var
     i, d: Integer;
     c: Char;
    begin
     Result := '';
     for i := 1 to 8 do
     begin
       d := value mod 16;
       c := digits[d];
       Result := c + Result;
       value := value div 16;
     end;
     Result := '$'+Result;
    end;
    procedure gen(name: String; value: msp_DWORD);
    begin
      writeln(name, #9#9#9'= ' , toHex(value), ';');
    end;
    procedure ali(name, value: String);
    begin
      writeln(name, #9#9#9'= ', value, ';');
    end;
    procedure wrl(s: String);
    begin
      writeln(s);
    end;
begin
wrl('const');
wrl('//Common flags');
gen('mspF_CURRENT_AREA                   ',         MakeFLAGID(mspRR_CONFIG1, 13));
ali('mspF_CURRENT_AREA_B                 ',         'mspF_CURRENT_AREA');
gen('mspF_CURRENT_AREA_A                 ',         StarFLAGID(mspRR_CONFIG1, 13));
gen('mspF_LOWER_CLOCK_SELECT             ',         MakeFLAGID(mspRR_CONFIG5, 15));
gen('mspF_DOUBLE_SAMPLE_FREQUENCY        ',         MakeFLAGID(mspRR_CONFIG5, 11));
ali('mspF_EXPANDED_ZERO_CROSSING_ENABLED ',		      'mspF_DOUBLE_SAMPLE_FREQUENCY');
gen('mspF_GAP_CHECK_ENABLED              ',         MakeFLAGID(mspRR_CONFIG5, 8));
gen('mspF_256WORD_BOUNDARY_DISABLE       ',	        MakeFLAGID(mspRR_CONFIG2, 10));
gen('mspF_ENHANCED_MODE                  ',         MakeFLAGID(mspRR_CONFIG3, 15));
gen('mspF_ENHANCED_CPU_ACCESS            ',         MakeFLAGID(mspRR_CONFIG6, 14));
wrl('');

wrl('//BC mode flags');
gen('mspF_MESSAGE_STOP_ON_ERROR          ',  MakeFLAGID(mspRR_CONFIG1, 12));
gen('mspF_FRAME_STOP_ON_ERROR            ',	 MakeFLAGID(mspRR_CONFIG1, 11));
gen('mspF_STATUS_SET_STOP_ON_MESSSAGE    ',  MakeFLAGID(mspRR_CONFIG1, 10));
gen('mspF_STATUS_SET_STOP_ON_FRAME       ',  MakeFLAGID(mspRR_CONFIG1, 9));
gen('mspF_FRAME_AUTOREPEAT               ',  MakeFLAGID(mspRR_CONFIG1, 8));
gen('mspF_EXTERNAL_TRIGGER_ENABLED       ',  MakeFLAGID(mspRR_CONFIG1, 7));
gen('mspF_INTERNAL_TRIGGER_ENABLED       ',  MakeFLAGID(mspRR_CONFIG1, 6));
gen('mspF_MESSAGE_GAP_TIMER_ENABLED      ',  MakeFLAGID(mspRR_CONFIG1, 5));
gen('mspF_RETRY_ENABLED                  ',  MakeFLAGID(mspRR_CONFIG1, 4));
gen('mspF_DOUBLE_RETRY                   ',  MakeFLAGID(mspRR_CONFIG1, 3));
gen('mspF_BC_ENABLED                     ',  MakeFLAGID(mspRR_CONFIG1, 2));
gen('mspF_BC_FRAME_IN_PROGRESS           ',  MakeFLAGID(mspRR_CONFIG1, 1));
gen('mspF_BC_MESSAGE_IN_PROGRESS         ',  MakeFLAGID(mspRR_CONFIG1, 0));
gen('mspF_EXPANDED_BC_CONTROL_WORD       ',  MakeFLAGID(mspRR_CONFIG4, 12));
gen('mspF_BROADCAST_MASK_ENABLED         ',  MakeFLAGID(mspRR_CONFIG4, 11));
gen('mspF_RETRY_IF_1553A_AND_MESSAGE_ERROR', MakeFLAGID(mspRR_CONFIG4, 10));
gen('mspF_RETRY_IF_STATUS_SET            ',  MakeFLAGID(mspRR_CONFIG4, 9));
gen('mspF_RETRY1_AT_ALT_BUS              ',  MakeFLAGID(mspRR_CONFIG4, 8));
gen('mspF_RETRY2_AT_ALT_BUS              ',  MakeFLAGID(mspRR_CONFIG4, 7));
gen('mspF_VALID_ERROR_BIT_NO_DATA        ',  MakeFLAGID(mspRR_CONFIG4, 6));
gen('mspF_VALID_BUSY_BIT_NO_DATA         ',  MakeFLAGID(mspRR_CONFIG4, 5));
wrl('');

wrl('//lve RT, RT/MM, MM flags');
gen('mspF_INCREMENT_ON_EOM               ',  MakeFLAGID(mspRR_CONFIG6, 13));
wrl('');

wrl('//RT mode flags');
gen('mspF_NOT_ACCEPT_DYNAMIC_BUS_CONTROL',    MakeFLAGID(mspRR_CONFIG1, 11));
gen('mspF_ACCEPT_DYNAMIC_BUS_CONTROL    ',    StarFLAGID(mspRR_CONFIG1, 11));
gen('mspF_NOT_BUSY                      ',    MakeFLAGID(mspRR_CONFIG1, 10));
gen('mspF_BUSY                          ',    StarFLAGID(mspRR_CONFIG1, 10));
gen('mspF_NOT_SERVICE_REQUEST           ',    MakeFLAGID(mspRR_CONFIG1, 9));
gen('mspF_SERVICE_REQUEST               ',    StarFLAGID(mspRR_CONFIG1, 9));
gen('mspF_NOT_SUBSYSTEM_FLAG            ',    MakeFLAGID(mspRR_CONFIG1, 8));
gen('mspF_SUBSYSTEM_FLAG                ',    StarFLAGID(mspRR_CONFIG1, 8));
gen('mspF_NOT_RTFLAG                    ',    MakeFLAGID(mspRR_CONFIG1, 7));
gen('mspF_RTFLAG                        ',    StarFLAGID(mspRR_CONFIG1, 7));
gen('mspF_RT_MESSAGE_IN_PROGRESS        ',    MakeFLAGID(mspRR_CONFIG1, 0));
wrl('');

gen('mspF_S10                           ',    MakeFLAGID(mspRR_CONFIG1, 11));
gen('mspF_S09                           ',    MakeFLAGID(mspRR_CONFIG1, 10));
gen('mspF_S08                           ',    MakeFLAGID(mspRR_CONFIG1, 9));
gen('mspF_S07                           ',    MakeFLAGID(mspRR_CONFIG1, 8));
gen('mspF_S06                           ',    MakeFLAGID(mspRR_CONFIG1, 7));
gen('mspF_S05                           ',    MakeFLAGID(mspRR_CONFIG1, 6));
gen('mspF_S04                           ',    MakeFLAGID(mspRR_CONFIG1, 5));
gen('mspF_S03                           ',    MakeFLAGID(mspRR_CONFIG1, 4));
gen('mspF_S02                           ',    MakeFLAGID(mspRR_CONFIG1, 3));
gen('mspF_S01                           ',    MakeFLAGID(mspRR_CONFIG1, 2));
gen('mspF_S00                           ',    MakeFLAGID(mspRR_CONFIG1, 1));
ali('mspF_ALTSTATUS_MESSAGE_ERROR       ',    'mspF_S10');
ali('mspF_ALTSTATUS_INSTRUMENTATION	    ',		'mspF_S09');
ali('mspF_ALTSTATUS_SERVICE_REQUEST     ',    'mspF_S08');
ali('mspF_ALTSTATUS_RESERVED_12	        ',	  'mspF_S07');
ali('mspF_ALTSTATUS_RESERVED_13	        ',	  'mspF_S06');
ali('mspF_ALTSTATUS_RESERVED_14	        ',	  'mspF_S05');
ali('mspF_ALTSTATUS_BROADCAST_COMMAND_RECEIVED',	'mspF_S04');
ali('mspF_ALTSTATUS_BUSY                ',    'mspF_S03');
ali('mspF_ALTSTATUS_SUBSYSTEM_FLAG      ',    'mspF_S02');
ali('mspF_ALTSTATUS_ACCEPT_DYNAMIC_BUS_CONTROL',  'mspF_S01');
ali('mspF_ALTSTATUS_TERMINAL_FLAG       ',    'mspF_S00');
wrl('');

gen('mspF_MULTIRT_ENABLE                ',    MakeFLAGID(mspRR_CONFIG2, 14));
gen('mspF_BUSY_BIT_LOOKUP_TABLE_ENABLE  ',    MakeFLAGID(mspRR_CONFIG2, 13));
gen('mspF_DOUBLE_BUFFERING_ENABLE       ',    MakeFLAGID(mspRR_CONFIG2, 12));
gen('mspF_OVERWRITE_INVALID_DATA        ',    MakeFLAGID(mspRR_CONFIG2, 11));
gen('mspF_CLEAR_TIME_TAG_ON_SYNCHRONIZE ',    MakeFLAGID(mspRR_CONFIG2, 6));
gen('mspF_LOAD_TIME_TAG_ON_SYNCHRONIZE  ',    MakeFLAGID(mspRR_CONFIG2, 5));
gen('mspF_CLEAR_SERVICE_REQUEST         ',    MakeFLAGID(mspRR_CONFIG2, 2));
gen('mspF_ENHANCED_RT_MEMORY_MANAGEMENT ',    MakeFLAGID(mspRR_CONFIG2, 1));
gen('mspF_SEPARATE_BROADCAST_DATA       ',    MakeFLAGID(mspRR_CONFIG2, 0));
gen('mspF_ILLEGALIZATION_DISABLED       ',    MakeFLAGID(mspRR_CONFIG3, 7));
gen('mspF_OVERRIDE_MODE_CODE_BIT_ERROR  ',    MakeFLAGID(mspRR_CONFIG3, 6));
gen('mspF_ALTERNATE_RT_STATUS_WORD_ENABLED',  MakeFLAGID(mspRR_CONFIG3, 5));
gen('mspF_ILLEGAL_RECEIVE_TRANSFER_DISABLE',  MakeFLAGID(mspRR_CONFIG3, 4));
gen('mspF_BUSY_RECEIVE_TRANSFER_DISABLE ',    MakeFLAGID(mspRR_CONFIG3, 3));
gen('mspF_RTF_WRAP_ENABLE               ',    MakeFLAGID(mspRR_CONFIG3, 2));
gen('mspF_1553A_MODE_CODES_ENABLED      ',    MakeFLAGID(mspRR_CONFIG3, 1));
gen('mspF_ENHANCED_MODE_CODE_HANDLING   ',    MakeFLAGID(mspRR_CONFIG3, 0));
gen('mspF_EXTERNAL_BIT_WORD_ENABLE      ',    MakeFLAGID(mspRR_CONFIG4, 15));
gen('mspF_INHIBIT_BIT_WORD_TRANSMIT_IF_BUSY', MakeFLAGID(mspRR_CONFIG4, 14));
gen('mspF_MODE_CODE_OVERRIDE_BUSY       ',    MakeFLAGID(mspRR_CONFIG4, 13));
gen('mspF_BROADCAST_DISABLED            ',    MakeFLAGID(mspRR_CONFIG5, 7));
wrl('');

wrl('//MT mode flags');
gen('mspF_MONITOR_TRIGGER_ENABLED	      ',		MakeFLAGID(mspRR_CONFIG1, 11));
gen('mspF_START_ON_TRIGGER              ',    MakeFLAGID(mspRR_CONFIG1, 10));
gen('mspF_STOP_ON_TRIGGER               ',    MakeFLAGID(mspRR_CONFIG1, 9));
gen('//mspF_EXTERNAL_TRIGGER_ENABLED	    ',		MakeFLAGID(mspRR_CONFIG1, 7));
gen('mspF_MONITOR_ENABLED               ',    MakeFLAGID(mspRR_CONFIG1, 2));
gen('mspF_MONITOR_TRIGGERED             ',    MakeFLAGID(mspRR_CONFIG1, 1));
gen('mspF_MONITOR_ACTIVE                ',    MakeFLAGID(mspRR_CONFIG1, 0));
gen('//mspF_1553A_MODE_CODES_ENABLED	    ',		MakeFLAGID(mspRR_CONFIG3, 1));
gen('mspF_MONITOR_TAG_GAP_OPTION        ',    MakeFLAGID(mspRR_CONFIG4, 4));
gen('//mspF_BROADCAST_DISABLED            ',    MakeFLAGID(mspRR_CONFIG5, 7));
wrl('');

wrl('//Interrupt control flags');
gen('mspF_ENHANCED_INTERRUPTS           ',    MakeFLAGID(mspRR_CONFIG2, 15));
gen('mspF_INTERRUPT_STATUS_AUTO_CLEAR   ',    MakeFLAGID(mspRR_CONFIG2, 4));
gen('mspF_LEVEL_INTERRUPTS              ',    MakeFLAGID(mspRR_CONFIG2, 3));
gen('mspF_PULSE_INTERRUPTS              ',    StarFLAGID(mspRR_CONFIG2, 3));
wrl('');

wrl('//External config flags');
gen('mspFE_BUS_TRANSPARENT_MODE	   ',			MakeFLAGID(mspRR_EXTERNAL_CONFIG, 0));
gen('mspFE_BUS_BUFFERED_MODE		   ',			StarFLAGID(mspRR_EXTERNAL_CONFIG, 0));
gen('mspFE_BUS_BUFFERED_WORD		   ',			MakeFLAGID(mspRR_EXTERNAL_CONFIG, 1));
gen('mspFE_BUS_BUFFERED_BYTE		   ',			StarFLAGID(mspRR_EXTERNAL_CONFIG, 1));
gen('mspFE_POLARITY                     ',    MakeFLAGID(mspRR_EXTERNAL_CONFIG, 2));
gen('mspFE_NONZEROWAIT                  ',    MakeFLAGID(mspRR_EXTERNAL_CONFIG, 3));
ali('mspFE_NOT_ZEROWAIT                 ',    'mspFE_NONZEROWAIT');
gen('mspFE_ZEROWAIT                     ',    StarFLAGID(mspRR_EXTERNAL_CONFIG, 3));
gen('mspFE_ADDR_LAT                     ',    MakeFLAGID(mspRR_EXTERNAL_CONFIG, 4));
gen('mspFE_TRIGGER_SEL                  ',    MakeFLAGID(mspRR_EXTERNAL_CONFIG, 5));
gen('mspFE_EXT_TRIG                     ',    MakeFLAGID(mspRR_EXTERNAL_CONFIG, 7));
gen('mspFE_NOT_SSFLAG                   ',    MakeFLAGID(mspRR_EXTERNAL_CONFIG, 7));
gen('mspFE_SSFLAG                       ',    StarFLAGID(mspRR_EXTERNAL_CONFIG, 7));
gen('mspFE_NOT_INCMD                    ',    MakeFLAGID(mspRR_EXTERNAL_CONFIG, 8));
gen('mspFE_INCMD                        ',    StarFLAGID(mspRR_EXTERNAL_CONFIG, 8));
wrl('');

wrl('//Software flags');
gen('mspFS_RT_SET_BUSY_FOR_BUFFER       ',    MakeFLAGID(mspRR_SOFTWARE1, 0));
gen('mspFS_RT_ILLEGALIZE_FOR_BUFFER     ',    MakeFLAGID(mspRR_SOFTWARE1, 1));
gen('mspFS_RT_SAFE_RETRIEVE		          ', 		MakeFLAGID(mspRR_SOFTWARE1, 2));
gen('mspFS_MRT_REGISTER_OVERRIDE	      ', 		MakeFLAGID(mspRR_SOFTWARE1, ofs_MRT_REGISTER_OVERRIDE));
gen('mspFS_MRT_REGISTER_NOT_OVERRIDE	  ',		StarFLAGID(mspRR_SOFTWARE1, ofs_MRT_REGISTER_OVERRIDE));
gen('mspFS_DISPATCH_KEEP_INTERRUPT	    ',		MakeFLAGID(mspRR_SOFTWARE1, 5));
wrl('');

wrl('//Virtual registers');
gen('mspR_RT_STATUS_WORD                ',    MakeALIAS(mspRR_RT_STATUS_WORD));
gen('mspR_TIME_TAG_RESOLUTION           ',    MakeREGID(mspRR_CONFIG2, $380));
wrl('          //:');
wrl('          msp_TIME_TAG_RESOLUTION_64us            = $0000;');
wrl('          msp_TIME_TAG_RESOLUTION_32us            = $0080;');
wrl('          msp_TIME_TAG_RESOLUTION_16us            = $0100;');
wrl('          msp_TIME_TAG_RESOLUTION_8us             = $0180;');
wrl('          msp_TIME_TAG_RESOLUTION_4us             = $0200;');
wrl('          msp_TIME_TAG_RESOLUTION_2us             = $0280;');
wrl('          msp_TIME_TAG_RESOLUTION_TEST_MODE       = $0300;');
wrl('          msp_TIME_TAG_RESOLUTION_EXT_CLOCK       = $0380;');
gen('mspR_COMMAND_STACK_POINTER         ',    MakeALIAS(mspRR_COMMAND_STACK_POINTER));
gen('mspR_CONTROL_WORD                  ',    MakeALIAS(mspRR_CONTROL_WORD));
gen('mspR_TIME_TAG                      ',    MakeALIAS(mspRR_TIME_TAG));
gen('mspR_COMMAND_STACK_SIZE            ',    MakeREGID(mspRR_CONFIG3, $6000));
wrl('//  /.');
wrl('        //:');
wrl('          msp_STACK_SIZE_64			  = $0000;');
wrl('          msp_STACK_SIZE_128       = $2000;');
wrl('          msp_STACK_SIZE_256       = $4000;');
wrl('          msp_STACK_SIZE_512       = $6000;');
wrl('        //(   )');
gen('mspR_MT_COMMAND_STACK_SIZE         ',    MakeREGID(mspRR_CONFIG3, $1800));
wrl('//  .');
wrl('        //:');
wrl('          msp_MT_CSTACK_SIZE_64    = $0000;');
wrl('          msp_MT_CSTACK_SIZE_256   = $0800;');
wrl('          msp_MT_CSTACK_SIZE_1024  = $1000;');
wrl('          msp_MT_CSTACK_SIZE_4096  = $1800;');
wrl('        //(   )');
gen('mspR_MT_DATA_STACK_SIZE            ',    MakeREGID(mspRR_CONFIG3, $0700));
wrl('//  .');
wrl('        //:');
wrl('          msp_MT_DSTACK_SIZE_64K   = $0000;');
wrl('          msp_MT_DSTACK_SIZE_32K   = $0100;');
wrl('          msp_MT_DSTACK_SIZE_16K   = $0200;');
wrl('          msp_MT_DSTACK_SIZE_8K    = $0300;');
wrl('          msp_MT_DSTACK_SIZE_4K    = $0400;');
wrl('          msp_MT_DSTACK_SIZE_2K    = $0500;');
wrl('          msp_MT_DSTACK_SIZE_1K    = $0600;');
wrl('          msp_MT_DSTACK_SIZE_512   = $0700;');
wrl('        //(   )');
gen('mspR_RESPONSE_TIMEOUT              ',    MakeREGID(mspRR_CONFIG5, $0600));
wrl('        //:');
wrl('          msp_RESPONSE_TIMEOUT_18us5   = $0000;');
wrl('          msp_RESPONSE_TIMEOUT_22us5   = $0200;');
wrl('          msp_RESPONSE_TIMEOUT_50us5   = $0400;');
wrl('          msp_RESPONSE_TIMEOUT_130us   = $0600;');
gen('mspR_DATA_STACK_ADDRESS            ',    MakeALIAS(mspRR_DATA_STACK_ADDRESS));
gen('mspR_BC_FRAME_TIME_REMAINING	      ',		MakeALIAS(mspRR_FRAME_TIME_REMAINING));
gen('mspR_BC_MESSAGE_TIME_REMAINING	    ',		MakeALIAS(mspRR_MESSAGE_TIME_REMAINING));
gen('mspR_BC_FRAME_TIME                 ',    MakeALIAS(mspRR_BC_FRAME_TIME));
ali('mspR_RT_LAST_COMMAND               ',    'mspR_BC_FRAME_TIME');
ali('mspR_MT_TRIGGER                    ',    'mspR_BC_FRAME_TIME');
gen('//mspR_RT_STATUS_WORD                ',    MakeALIAS(mspRR_RT_STATUS_WORD));
gen('mspR_RT_BIT_WORD                   ',    MakeALIAS(mspRR_RT_BIT_WORD));
gen('mspR_INTERRUPT_MASK                ',    MakeALIAS(mspRR_INTERRUPT_MASK));
gen('mspR_INTERRUPT_STATUS              ',    MakeALIAS(mspRR_INTERRUPT_STATUS));
wrl('        //mspR_INTERRUPT_MASK  mspR_INTERRUPT_STATUS -  .');
wrl('        // :');
wrl('          mspM_MASTER_INTERRUPT                   = $8000; //  mspR_INTERRUPT_STATUS');
wrl('          mspM_RAM_PARITY_ERROR                   = $4000;');
wrl('          mspM_TRANSMITTER_TIMEOUT                = $2000;');
wrl('          mspM_COMMAND_STACK_ROLLOVER             = $1000;');
wrl('          mspM_MT_COMMAND_STACK_ROLLOVER          = $0800;');
wrl('          mspM_MT_DATA_STACK_ROLLOVER             = $0400;');
wrl('          mspM_HANDSHAKE_FAILURE                  = $0200;');
wrl('          mspM_BC_RETRY                           = $0100;');
wrl('          mspM_RT_ADDRESS_PARITY_ERROR            = $0080;');
wrl('          mspM_TIME_TAG_ROLLOVER                  = $0040;');
wrl('          mspM_RT_CIRCULAR_BUFFER_ROLLOVER        = $0020;');
wrl('          mspM_BCCW_EOM                           = $0010;');
wrl('          mspM_SACW_EOM                           = $0010;');
wrl('          mspM_BC_EOF                             = $0008;');
wrl('          mspM_FORMAT_ERROR                       = $0004;');
wrl('          mspM_BC_STATUS_SET                      = $0002;');
wrl('          mspM_RT_MODE_CODE                       = $0002;');
wrl('          mspM_MT_PATTERN_TRIGGER                 = $0002;');
wrl('          mspM_EOM                                = $0001;');
gen('mspR_RT_ADDRESS                    ',    OffsREGID(mspRR_CONFIG5, $003E, 1)); wrl('// ^ RO; autoshift');
gen('mspRE_RT_ADDRESS                   ',    MakeREGID(mspRR_EXTERNAL_RT_ADDRESS, $001F));

wrl('//Virtual aliases to other physical registers');
wrl('//NOT recommended for use programmatically,');
wrl('//BUT usefull for graphic shell trics');
gen('mspR_CONFIG1                       ',    MakeALIAS(mspRR_CONFIG1));
gen('mspR_CONFIG2                       ',    MakeALIAS(mspRR_CONFIG2));
gen('mspR_COMMAND                       ',    MakeALIAS(mspRR_COMMAND));
gen('mspR_CONFIG3                       ',    MakeALIAS(mspRR_CONFIG3));
gen('mspR_CONFIG4                       ',    MakeALIAS(mspRR_CONFIG4));
gen('mspR_CONFIG5                       ',    MakeALIAS(mspRR_CONFIG5));
gen('mspRE_EXTERNAL_CONFIG		          ', 		MakeALIAS(mspRR_EXTERNAL_CONFIG));
wrl('');

wrl('//MRT mode flags & vregisters');
gen('mspR_MRT_ADDRESS                   ',   MakeALIAS(mspRR_MRT_ADDRESS));
gen('mspR_MRT_CONFIG1                   ',   MakeALIAS(mspRR_MRT_CONFIG1));
gen('	mspF_MRT_S10               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 11));
gen('	mspF_MRT_S09               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 10));
gen('	mspF_MRT_S08               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 9));
gen('	mspF_MRT_S07               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 8));
gen('	mspF_MRT_S06               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 7));
gen('	mspF_MRT_S05               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 6));
gen('	mspF_MRT_S04               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 5));
gen('	mspF_MRT_S03               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 4));
gen('	mspF_MRT_S02               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 3));
gen('	mspF_MRT_S01               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 2));
gen('	mspF_MRT_S00               ',            MakeFLAGID(mspRR_MRT_CONFIG1, 1));
ali('	mspF_MRT_ALTSTATUS_MESSAGE_ERROR',       'mspF_MRT_S10');
ali('	mspF_MRT_ALTSTATUS_INSTRUMENTATION',	   'mspF_MRT_S09');
ali('	mspF_MRT_ALTSTATUS_SERVICE_REQUEST',     'mspF_MRT_S08');
ali('	mspF_MRT_ALTSTATUS_RESERVED_12',		    'mspF_MRT_S07');
ali('	mspF_MRT_ALTSTATUS_RESERVED_13',	      'mspF_MRT_S06');
ali('	mspF_MRT_ALTSTATUS_RESERVED_14',		    'mspF_MRT_S05');
ali('	mspF_MRT_ALTSTATUS_BROADCAST_COMMAND_RECEIVED',	'mspF_MRT_S04');
ali('	mspF_MRT_ALTSTATUS_BUSY       ',         'mspF_MRT_S03');
ali('	mspF_MRT_ALTSTATUS_SUBSYSTEM_FLAG',      'mspF_MRT_S02');
ali('	mspF_MRT_ALTSTATUS_ACCEPT_DYNAMIC_BUS_CONTROL',	'mspF_MRT_S01');
ali('	mspF_MRT_ALTSTATUS_TERMINAL_FLAG',       'mspF_MRT_S00');
gen('	mspF_MRT_NOT_ACCEPT_DYNAMIC_BUS_CONTROL', MakeFLAGID(mspRR_MRT_CONFIG1, 11));
gen('	mspF_MRT_ACCEPT_DYNAMIC_BUS_CONTROL',    StarFLAGID(mspRR_MRT_CONFIG1, 11));
gen('	mspF_MRT_BUSY              ',            StarFLAGID(mspRR_MRT_CONFIG1, 10));
gen('	mspF_MRT_NOT_SERVICE_REQUEST',           MakeFLAGID(mspRR_MRT_CONFIG1, 9));
gen('	mspF_MRT_SERVICE_REQUEST   ',            StarFLAGID(mspRR_MRT_CONFIG1, 9));
gen('	mspF_MRT_NOT_SUBSYSTEM_FLAG',            MakeFLAGID(mspRR_MRT_CONFIG1, 8));
gen('	mspF_MRT_SUBSYSTEM_FLAG    ',            StarFLAGID(mspRR_MRT_CONFIG1, 8));
gen('	mspF_MRT_NOT_RTFLAG        ',            MakeFLAGID(mspRR_MRT_CONFIG1, 7));
gen('	mspF_MRT_RTFLAG            ',            StarFLAGID(mspRR_MRT_CONFIG1, 7));
gen(' mspR_MRT_STATUS            ',            MakeALIAS(mspRR_MRT_STATUS));
gen('	mspF_MRT_MESSAGE_IN_PROGRESS',			     MakeFLAGID(mspRR_MRT_STATUS, 15));
gen('	mspR_MRT_ISR_FIFO_COUNTER  ',            MakeREGID(mspRR_MRT_STATUS, $000F));
gen('	mspR_MRT_ACTIVE_RT         ',            OffsREGID(mspRR_MRT_STATUS, $1F00, 8));
gen('mspR_MRT_INTERRUPT_STATUS          ',    MakeALIAS(mspRR_MRT_INTERRUPT_STATUS));
wrl('      mspM_MRT_TRANSMITTER_TIMEOUT        = $2000;');
wrl('      mspM_MRT_COMMAND_STACK_ROLLOVER     = $1000;');
wrl('      mspM_MRT_HANDSHAKE_FAILURE          = $0200;');
wrl('      mspM_MRT_TIME_TAG_ROLLOVER          = $0040;');
wrl('      mspM_MRT_RT_CIRCULAR_BUFFER_ROLLOVER= $0020;');
wrl('      mspM_MRT_SACW_EOM                   = $0010;');
wrl('      mspM_MRT_FORMAT_ERROR               = $0004;');
wrl('      mspM_MRT_RT_MODE_CODE               = $0002;');
wrl('      mspM_MRT_EOM                        = $0001;');
gen('mspR_MRT_ISR_RT_ADDRESS            ',    MakeREGID(mspRR_MRT_INTERRUPT_STATUS, $FF00));
gen('mspR_MRT_COMMAND_WORD              ',    MakeALIAS(mspRR_MRT_COMMAND_WORD));
gen('mspR_MRT_STATUS_WORD               ',    MakeALIAS(mspRR_MRT_STATUS_WORD));
gen('mspR_SOFTWARE2_MRT_ISR             ',    MakeALIAS(mspRR_SOFTWARE2_MRT_ISR));
wrl('');

wrl('///////////////////////////////    /////////////////////////////////////////');
wrl('//  ');
gen('mspR_WG_DATA_STACK_POINTER	        ',	MakeALIAS(mspRR_WG_DATA_STACK_POINTER));
gen('mspR_WG_INITIAL_DATA_STACK_POINTER ',	MakeALIAS(mspRR_WG_INITIAL_DATA_STACK_POINTER));
wrl('// ');
gen('mspF_GENERATOR_ACTIVE              ',  MakeFLAGID(mspRR_CONFIG1,3));
end;
{$EndIf}

function FormatCommandWord(DIR: msp_DIR; RT: msp_BYTE; SA: msp_BYTE; WCNT: msp_BYTE ): msp_WORD;
begin
 if DIR = msp_DIR_TX then Result := $0400 else Result := 0;
 Result := Result or ((RT and $1F) shl 11) or ((SA and $1F) shl 5) or (WCNT and $1F);
end;

procedure ParseCommandWord(CMD: msp_WORD; var TX: msp_DIR; var RT, SA, WCNT: msp_BYTE);
begin
  TX := ord((CMD and $0400) <> 0);
  RT := CMD shr 11;
  SA := (CMD shr 5) and $1F;
  WCNT := CMD and $1F;
end;

procedure CorrectWCNT(var WCNT: msp_BYTE);
begin if WCNT = 0 then WCNT := 32 end;

function StatusRTADD(CMD: msp_WORD): msp_BYTE;
begin Result := CMD shr 11 end;

function msp_FillHandle(handle: msp_RAMHANDLE; data: msp_WORD): msp_ERROR;
begin
  Result := msp_FillRamBLK(msp_DeviceOf(handle), msp_AddressOf(handle), data,
                 msp_SizeOf(handle))
end;

function msp_rangeCmdBUSY(DIR: msp_DIR; RT: msp_WORD; SA0, SA1: msp_WORD): msp_rangeCmdWords;
var
  DIR1, RT1: msp_WORD;
begin
  if DIR = msp_RANGE_ALL then DIR1 := msp_DIR_RX else DIR1 := DIR;
  if RT = msp_RANGE_ALL then RT1 := 0 else RT1 := RT;
  Result.rangeCmdWord0 := FormatCommandWord(DIR1, RT1, SA0, 0);
  if DIR = msp_RANGE_ALL then DIR1 := msp_DIR_TX else DIR1 := DIR;
  if RT = msp_RANGE_ALL then RT1 := 31 else RT1 := RT;
  Result.rangeCmdWord1 := FormatCommandWord(DIR1, RT1, SA1, 0);
end;

function msp_rangeCmdILL(DIR: msp_DIR; RT: msp_WORD;
     SA0, SA1, WC0, WC1: msp_WORD): msp_rangeCmdWords;
var
  DIR1, RT1: msp_WORD;
begin
  if DIR = msp_RANGE_ALL then DIR1 := msp_DIR_RX else DIR1 := DIR;
  if RT = msp_RANGE_ALL then RT1 := 0 else RT1 := RT;
  Result.rangeCmdWord0 := FormatCommandWord(DIR1, RT1, SA0, WC0);
  if DIR = msp_RANGE_ALL then DIR1 := msp_DIR_TX else DIR1 := DIR;
  if RT = msp_RANGE_ALL then RT1 := 31 else RT1 := RT;
  Result.rangeCmdWord1 := FormatCommandWord(DIR1, RT1, SA1, WC1);
end;

function msp_rangeCmdMT(DIR: msp_DIR; RT0, RT1: msp_WORD;
     SA0, SA1: msp_WORD): msp_rangeCmdWords;
var
  DIR1: msp_WORD;
begin
  if DIR = msp_RANGE_ALL then DIR1 := msp_DIR_RX else DIR1 := DIR;
  Result.rangeCmdWord0 := FormatCommandWord(DIR1, RT0, SA0, 0);
  if DIR = msp_RANGE_ALL then DIR1 := msp_DIR_TX else DIR1 := DIR;
  Result.rangeCmdWord0 := FormatCommandWord(DIR1, RT1, SA1, 0);
end;

function msp_rangeAll: msp_rangeCmdWords;
begin
  Result.rangeCmdWord0 := $0000;
  Result.rangeCmdWord1 := $FFFF;
end;

function msp_Start(device: msp_DEVHANDLE): msp_ERROR;
begin Result := msp_Command(device, mspC_START) end;
function msp_Reset(device: msp_DEVHANDLE): msp_ERROR;
begin Result := msp_Command(device, mspC_RESET) end;
function msp_ResetInterrupt(device: msp_DEVHANDLE): msp_ERROR;
begin Result := msp_Command(device, mspC_INTERRUPT_RESET) end;
function msp_ResetTimeTag(device: msp_DEVHANDLE): msp_ERROR;
begin Result := msp_Command(device, mspC_TIME_TAG_RESET) end;
function msp_TimeTagTestClock(device: msp_DEVHANDLE): msp_ERROR;
begin Result := msp_Command(device, mspC_TIME_TAG_TEST_CLOCK) end;
function msp_StopOnFrame(device: msp_DEVHANDLE): msp_ERROR;
begin Result := msp_Command(device, mspC_STOP_ON_FRAME) end;
function msp_StopOnMessage(device: msp_DEVHANDLE): msp_ERROR;
begin Result := msp_Command(device, mspC_STOP_ON_MESSAGE) end;

function msp_Open; external 'drtl3.dll' name 'msp_Open';
function msp_OpenEx; external 'drtl3.dll' name 'msp_OpenEx';
function msp_Close; external 'drtl3.dll' name 'msp_Close';
function msp_Open_Multi; external 'drtl3.dll' name 'msp_Open_Multi';
function msp_Switch_Multi; external 'drtl3.dll' name 'msp_Switch_Multi';
function msp_GetFlag; external 'drtl3.dll' name 'msp_GetFlag';
function msp_SetFlag; external 'drtl3.dll' name 'msp_SetFlag';
function msp_SetFlagsIndirect; external 'drtl3.dll' name 'msp_SetFlagsIndirect';
function msp_GetVReg; external 'drtl3.dll' name 'msp_GetVReg';
function msp_SetVReg; external 'drtl3.dll' name 'msp_SetVReg';
function msp_SetVRegsIndirect; external 'drtl3.dll' name 'msp_SetVRegsIndirect';
function msp_SelectMode; external 'drtl3.dll' name 'msp_SelectMode';
function msp_Configure; external 'drtl3.dll' name 'msp_Configure';
function msp_Command; external 'drtl3.dll' name 'msp_Command';
function msp_RetrieveMessage; external 'drtl3.dll' name 'msp_RetrieveMessage';
function msp_ReadStackWord; external 'drtl3.dll' name 'msp_ReadStackWord';
function msp_GetMessageStatus; external 'drtl3.dll' name 'msp_GetMessageStatus';
function msp_GetCurrentEntry; external 'drtl3.dll' name 'msp_GetCurrentEntry';
function msp_ResetStack; external 'drtl3.dll' name 'msp_ResetStack';
function msp_AddressOf; external 'drtl3.dll' name 'msp_AddressOf';
function msp_SizeOf; external 'drtl3.dll' name 'msp_SizeOf';
function msp_HandleFrom; external 'drtl3.dll' name 'msp_HandleFrom';
function msp_DeviceOf; external 'drtl3.dll' name 'msp_DeviceOf';
function msp_DestroyHandle; external 'drtl3.dll' name 'msp_DestroyHandle';
function msp_RamTotal; external 'drtl3.dll' name 'msp_RamTotal';
function msp_RamFree; external 'drtl3.dll' name 'msp_RamFree';
function msp_EraseRam; external 'drtl3.dll' name 'msp_EraseRam';
function msp_FixedRam; external 'drtl3.dll' name 'msp_FixedRam';

initialization
  //InitIds;
end.
