unit mt;

interface

uses access, config;

function msp_ReadWordTrace(device: msp_DEVHANDLE; index: msp_WORD): msp_DWORD;

const
msp_WM_GAP_TIME_mask  = $FF00;
msp_WM_WORD_FLAG		  = $0080;
msp_WM_N_THIS_RT		  = $0040;
msp_WM_N_BROADCAST		= $0020;
msp_WM_ERROR			    = $0010;
msp_WM_SYNC_TYPE		  = $0008;  //1 for command, 0 for data
msp_WM_CHANNEL			  = $0004;	//1 for B, 0 for A
msp_WM_N_GAP			    = $0002;
msp_WM_N_MODECODE		  = $0001;

msp_WMD_GAP_TIME_mask	= (msp_WM_GAP_TIME_mask shl 16);
msp_WMD_WORD_FLAG		  = (msp_WM_WORD_FLAG shl 16);
msp_WMD_N_THIS_RT		  = (msp_WM_N_THIS_RT shl 16);
msp_WMD_N_BROADCAST		= (msp_WM_N_BROADCAST shl 16);
msp_WMD_ERROR			    = (msp_WM_ERROR shl 16);
msp_WMD_SYNC_TYPE		  = (msp_WM_SYNC_TYPE shl 16);
msp_WMD_CHANNEL			  = (msp_WM_CHANNEL shl 16);
msp_WMD_N_GAP			    = (msp_WM_N_GAP shl 16);
msp_WMD_N_MODECODE		= (msp_WM_N_MODECODE shl 16);

function msp_WM_GAP_TIME(W: msp_WORD): msp_BYTE;
function msp_WMD_GAP_TIME(W: msp_DWORD): msp_BYTE;

(***************************************************************
	   .
 ***************************************************************)

const
msp_MT_SELECTED	= 1;
msp_MT_UNSELECTED = 0;

function msp_MTSelectMessages(
				device: msp_DEVHANDLE;
				rangeCmdWord0, rangeCmdWord1: msp_WORD;
				select: msp_BIT): msp_ERROR; cdecl;
//    (   MT lookup table).
//device  
//rangeCmdWord0,
//rangeCmdWord1 -  1553,    
//		    sampleCmdWord1  
//		,  sampleCmdWord2 - ;
//		  <RT> (), <TX> (/*), <SA> ()
//		  <WCNT> (  )
//select     ;
//		 msp_MT_SELECTED (0x01)  msp_MT_UNSELECTED (0x00)

function msp_MTIsMessageSelected(device: msp_DEVHANDLE;
      sampleCmdWord: msp_WORD): msp_BIT; cdecl;
//       .

function msp_MTSelectMessagesIndirect(
				device: msp_DEVHANDLE;
				ranges: Pmsp_rangeCmdWords;
				count: integer;
				select: msp_BIT): msp_ERROR; cdecl;
//     
//device - 
//ranges -   rangeCmdWord0, rangeCmdWord1
//			    
//			msp_SelectMessages()
//count	-     ranges
//select     ;
//		 msp_MT_SELECTED (0x01)  msp_MT_UNSELECTED (0x00)

(***************************************************************
	\    
 ***************************************************************)

function msp_MTCreateStack(device: msp_DEVHANDLE): msp_STKHANDLE; cdecl;
//    (  )
//device  

function msp_MTDestroyStack(stack: msp_STKHANDLE): msp_ERROR;
// .
//stack   (handle) 
//:  

function msp_MTLoadStack(stack: msp_STKHANDLE; flags: Integer): msp_ERROR; cdecl;
//        (A  B).
//stack   (handle) 
//flags    
//	msp_STK_A     A
//	msp_STK_B     B

function msp_MTLoadStackWithOffset(stack: msp_STKHANDLE; start, flags: Integer): msp_ERROR; cdecl;
//       
//     
//stack   (handle) 
//start -   
//flags    
//	msp_STK_A     A
//	msp_STK_B     B

//See also msp_ResetStack (config.h)

(***************************************************************
	\    
 ***************************************************************)

type
msp_DSTKHANDLE = msp_RAMHANDLE;

function msp_MTCreateDataStack(device: msp_DEVHANDLE): msp_DSTKHANDLE; cdecl;
//  
//device  

function msp_MTDestroyDataStack(stack: msp_DSTKHANDLE): msp_ERROR;
//  
//device  

function msp_MTLoadDataStack(stack: msp_DSTKHANDLE; flags: Integer): msp_ERROR; cdecl;
//      
//stack -  
//flags    
//	msp_STK_A     A
//	msp_STK_B     B

function msp_MTLoadDataStackWithOffset(stack: msp_DSTKHANDLE;
      start: msp_WORD; flags: Integer): msp_ERROR; cdecl;
//        
// 
//stack -  
//start -      ()
//flags    
//	msp_STK_A     A
//	msp_STK_B     B

function msp_MTResetDataStack(stack: msp_DSTKHANDLE; address: msp_WORD): msp_ERROR; cdecl;
//    
//stack -  
//adsress -      ()
//   

(***************************************************************
      
 ***************************************************************)

function msp_MTRetrieveMessage(stack: msp_STKHANDLE; index: Integer;
    var buffer: msp_Message): msp_ERROR; cdecl;
//       ,          .
//stack  ;
//entry      
//buffer     .      StatusWord1/2, loopback, BSW, timetag.
//  msp_RetrieveMessage,    MT

implementation

function msp_ReadWordTrace(device: msp_DEVHANDLE; index: msp_WORD): msp_DWORD;
begin
  Result := msp_ReadRamDW(device, index shl 1);
end;

function msp_WM_GAP_TIME(W: msp_WORD): msp_BYTE;
begin
  Result := W shr 8;
end;

function msp_WMD_GAP_TIME(W: msp_DWORD): msp_BYTE;
begin
  Result := W shr 24;
end;

function msp_MTDestroyStack(stack: msp_STKHANDLE): msp_ERROR;
begin
  Result := msp_DestroyHandle(stack)
end;

function msp_MTDestroyDataStack(stack: msp_DSTKHANDLE): msp_ERROR;
begin
  Result := msp_DestroyHandle(stack)
end;

function msp_MTSelectMessages; external 'drtl3.dll' name 'msp_MTSelectMessages';
function msp_MTIsMessageSelected; external 'drtl3.dll' name 'msp_MTIsMessageSelected';
function msp_MTSelectMessagesIndirect; external 'drtl3.dll' name 'msp_MTSelectMessagesIndirect';
function msp_MTCreateStack; external 'drtl3.dll' name 'msp_MTCreateStack';
function msp_MTLoadStack; external 'drtl3.dll' name 'msp_MTLoadStack';
function msp_MTLoadStackWithOffset; external 'drtl3.dll' name 'msp_MTLoadStackWithOffset';
function msp_MTCreateDataStack; external 'drtl3.dll' name 'msp_MTCreateDataStack';
function msp_MTLoadDataStack; external 'drtl3.dll' name 'msp_MTLoadDataStack';
function msp_MTLoadDataStackWithOffset; external 'drtl3.dll' name 'msp_MTLoadDataStackWithOffset';
function msp_MTResetDataStack; external 'drtl3.dll' name 'msp_MTResetDataStack';
function msp_MTRetrieveMessage; external 'drtl3.dll' name 'msp_MTRetrieveMessage';

end.
